/*
 * Copyright 2023 Stanislav Mikhailov (xavetar)
 *
 * Licensed under the Creative Commons Zero v1.0 Universal (CC0) License.
 * You may obtain a copy of the License at
 *
 *     http://creativecommons.org/publicdomain/zero/1.0/
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the CC0 license is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

// It is strictly forbidden to use the from_code method, respected Microsoft decided to define
// duplicate codes, but by defining different constant names, therefore, when using these codes,
// it is mandatory to use through from_name, and not from_code. Otherwise, it may cause undefined
// behavior or an unknown exception. Because one code corresponds to several constants.

use super::{RawError};

#[derive(Clone, Debug, Copy, Eq, Hash, Ord, PartialEq, PartialOrd)]
pub enum DIRECTMUSIC {
    DSERR_CONTROLUNAVAIL,
    DSERR_INVALIDCALL,
    DSERR_PRIOLEVELNEEDED,
    DSERR_BADFORMAT,
    DSERR_NODRIVER,
    DSERR_BUFFERLOST,
    DSERR_OTHERAPPHASPRIO,
    DSERR_UNINITIALIZED,
    DSERR_DS8_REQUIRED,
    DMUS_E_DRIVER_FAILED,
    DMUS_E_PORTS_OPEN,
    DMUS_E_DEVICE_IN_USE,
    DMUS_E_INSUFFICIENTBUFFER,
    DMUS_E_BUFFERNOTSET,
    DMUS_E_BUFFERNOTAVAILABLE,
    DMUS_E_NOTADLSCOL,
    DMUS_E_INVALIDOFFSET,
    DMUS_E_ALREADY_LOADED,
    DMUS_E_INVALIDPOS,
    DMUS_E_INVALIDPATCH,
    DMUS_E_CANNOTSEEK,
    DMUS_E_CANNOTWRITE,
    DMUS_E_CHUNKNOTFOUND,
    DMUS_E_INVALID_DOWNLOADID,
    DMUS_E_NOT_DOWNLOADED_TO_PORT,
    DMUS_E_ALREADY_DOWNLOADED,
    DMUS_E_UNKNOWN_PROPERTY,
    DMUS_E_SET_UNSUPPORTED,
    DMUS_E_GET_UNSUPPORTED,
    DMUS_E_NOTMONO,
    DMUS_E_BADARTICULATION,
    DMUS_E_BADINSTRUMENT,
    DMUS_E_BADWAVELINK,
    DMUS_E_NOARTICULATION,
    DMUS_E_NOTPCM,
    DMUS_E_BADWAVE,
    DMUS_E_BADOFFSETTABLE,
    DMUS_E_UNKNOWNDOWNLOAD,
    DMUS_E_NOSYNTHSINK,
    DMUS_E_ALREADYOPEN,
    DMUS_E_ALREADYCLOSED,
    DMUS_E_SYNTHNOTCONFIGURED,
    DMUS_E_SYNTHACTIVE,
    DMUS_E_CANNOTREAD,
    DMUS_E_DMUSIC_RELEASED,
    DMUS_E_BUFFER_EMPTY,
    DMUS_E_BUFFER_FULL,
    DMUS_E_PORT_NOT_CAPTURE,
    DMUS_E_PORT_NOT_RENDER,
    DMUS_E_DSOUND_NOT_SET,
    DMUS_E_ALREADY_ACTIVATED,
    DMUS_E_INVALIDBUFFER,
    DMUS_E_WAVEFORMATNOTSUPPORTED,
    DMUS_E_SYNTHINACTIVE,
    DMUS_E_DSOUND_ALREADY_SET,
    DMUS_E_INVALID_EVENT,
    DMUS_E_UNSUPPORTED_STREAM,
    DMUS_E_ALREADY_INITED,
    DMUS_E_INVALID_BAND,
    DMUS_E_TRACK_HDR_NOT_FIRST_CK,
    DMUS_E_TOOL_HDR_NOT_FIRST_CK,
    DMUS_E_INVALID_TRACK_HDR,
    DMUS_E_INVALID_TOOL_HDR,
    DMUS_E_ALL_TOOLS_FAILED,
    DMUS_E_ALL_TRACKS_FAILED,
    DMUS_E_NOT_FOUND,
    DMUS_E_NOT_INIT,
    DMUS_E_TYPE_DISABLED,
    DMUS_E_TYPE_UNSUPPORTED,
    DMUS_E_TIME_PAST,
    DMUS_E_TRACK_NOT_FOUND,
    DMUS_E_TRACK_NO_CLOCKTIME_SUPPORT,
    DMUS_E_NO_MASTER_CLOCK,
    DMUS_E_LOADER_NOCLASSID,
    DMUS_E_LOADER_BADPATH,
    DMUS_E_LOADER_FAILEDOPEN,
    DMUS_E_LOADER_FORMATNOTSUPPORTED,
    DMUS_E_LOADER_FAILEDCREATE,
    DMUS_E_LOADER_OBJECTNOTFOUND,
    DMUS_E_LOADER_NOFILENAME,
    DMUS_E_INVALIDFILE,
    DMUS_E_ALREADY_EXISTS,
    DMUS_E_OUT_OF_RANGE,
    DMUS_E_SEGMENT_INIT_FAILED,
    DMUS_E_ALREADY_SENT,
    DMUS_E_CANNOT_FREE,
    DMUS_E_CANNOT_OPEN_PORT,
    DMUS_E_CANNOT_CONVERT,
    DMUS_E_DESCEND_CHUNK_FAIL,
    DMUS_E_NOT_LOADED,
    DMUS_E_SCRIPT_LANGUAGE_INCOMPATIBLE,
    DMUS_E_SCRIPT_UNSUPPORTED_VARTYPE,
    DMUS_E_SCRIPT_ERROR_IN_SCRIPT,
    DMUS_E_SCRIPT_CANTLOAD_OLEAUT32,
    DMUS_E_SCRIPT_LOADSCRIPT_ERROR,
    DMUS_E_SCRIPT_INVALID_FILE,
    DMUS_E_INVALID_SCRIPTTRACK,
    DMUS_E_SCRIPT_VARIABLE_NOT_FOUND,
    DMUS_E_SCRIPT_ROUTINE_NOT_FOUND,
    DMUS_E_SCRIPT_CONTENT_READONLY,
    DMUS_E_SCRIPT_NOT_A_REFERENCE,
    DMUS_E_SCRIPT_VALUE_NOT_SUPPORTED,
    DMUS_E_INVALID_SEGMENTTRIGGERTRACK,
    DMUS_E_INVALID_LYRICSTRACK,
    DMUS_E_INVALID_PARAMCONTROLTRACK,
    DMUS_E_AUDIOVBSCRIPT_SYNTAXERROR,
    DMUS_E_AUDIOVBSCRIPT_RUNTIMEERROR,
    DMUS_E_AUDIOVBSCRIPT_OPERATIONFAILURE,
    DMUS_E_AUDIOPATHS_NOT_VALID,
    DMUS_E_AUDIOPATHS_IN_USE,
    DMUS_E_NO_AUDIOPATH_CONFIG,
    DMUS_E_AUDIOPATH_INACTIVE,
    DMUS_E_AUDIOPATH_NOBUFFER,
    DMUS_E_AUDIOPATH_NOPORT,
    DMUS_E_NO_AUDIOPATH,
    DMUS_E_INVALIDCHUNK,
    DMUS_E_AUDIOPATH_NOGLOBALFXBUFFER,
    DMUS_E_INVALID_CONTAINER_OBJECT,
}

impl DIRECTMUSIC {
    pub fn code(&self) -> u32 {
        return match self {
            DIRECTMUSIC::DSERR_CONTROLUNAVAIL => 0x8878001E as u32,
            DIRECTMUSIC::DSERR_INVALIDCALL => 0x88780032 as u32,
            DIRECTMUSIC::DSERR_PRIOLEVELNEEDED => 0x88780046 as u32,
            DIRECTMUSIC::DSERR_BADFORMAT => 0x88780064 as u32,
            DIRECTMUSIC::DSERR_NODRIVER => 0x88780078 as u32,
            DIRECTMUSIC::DSERR_BUFFERLOST => 0x88780096 as u32,
            DIRECTMUSIC::DSERR_OTHERAPPHASPRIO => 0x887800A0 as u32,
            DIRECTMUSIC::DSERR_UNINITIALIZED => 0x887800AA as u32,
            DIRECTMUSIC::DSERR_DS8_REQUIRED => 0x887800BE as u32,
            DIRECTMUSIC::DMUS_E_DRIVER_FAILED => 0x88781101 as u32,
            DIRECTMUSIC::DMUS_E_PORTS_OPEN => 0x88781102 as u32,
            DIRECTMUSIC::DMUS_E_DEVICE_IN_USE => 0x88781103 as u32,
            DIRECTMUSIC::DMUS_E_INSUFFICIENTBUFFER => 0x88781104 as u32,
            DIRECTMUSIC::DMUS_E_BUFFERNOTSET => 0x88781105 as u32,
            DIRECTMUSIC::DMUS_E_BUFFERNOTAVAILABLE => 0x88781106 as u32,
            DIRECTMUSIC::DMUS_E_NOTADLSCOL => 0x88781108 as u32,
            DIRECTMUSIC::DMUS_E_INVALIDOFFSET => 0x88781109 as u32,
            DIRECTMUSIC::DMUS_E_ALREADY_LOADED => 0x88781111 as u32,
            DIRECTMUSIC::DMUS_E_INVALIDPOS => 0x88781113 as u32,
            DIRECTMUSIC::DMUS_E_INVALIDPATCH => 0x88781114 as u32,
            DIRECTMUSIC::DMUS_E_CANNOTSEEK => 0x88781115 as u32,
            DIRECTMUSIC::DMUS_E_CANNOTWRITE => 0x88781116 as u32,
            DIRECTMUSIC::DMUS_E_CHUNKNOTFOUND => 0x88781117 as u32,
            DIRECTMUSIC::DMUS_E_INVALID_DOWNLOADID => 0x88781119 as u32,
            DIRECTMUSIC::DMUS_E_NOT_DOWNLOADED_TO_PORT => 0x88781120 as u32,
            DIRECTMUSIC::DMUS_E_ALREADY_DOWNLOADED => 0x88781121 as u32,
            DIRECTMUSIC::DMUS_E_UNKNOWN_PROPERTY => 0x88781122 as u32,
            DIRECTMUSIC::DMUS_E_SET_UNSUPPORTED => 0x88781123 as u32,
            DIRECTMUSIC::DMUS_E_GET_UNSUPPORTED => 0x88781124 as u32,
            DIRECTMUSIC::DMUS_E_NOTMONO => 0x88781125 as u32,
            DIRECTMUSIC::DMUS_E_BADARTICULATION => 0x88781126 as u32,
            DIRECTMUSIC::DMUS_E_BADINSTRUMENT => 0x88781127 as u32,
            DIRECTMUSIC::DMUS_E_BADWAVELINK => 0x88781128 as u32,
            DIRECTMUSIC::DMUS_E_NOARTICULATION => 0x88781129 as u32,
            DIRECTMUSIC::DMUS_E_NOTPCM => 0x8878112A as u32,
            DIRECTMUSIC::DMUS_E_BADWAVE => 0x8878112B as u32,
            DIRECTMUSIC::DMUS_E_BADOFFSETTABLE => 0x8878112C as u32,
            DIRECTMUSIC::DMUS_E_UNKNOWNDOWNLOAD => 0x8878112D as u32,
            DIRECTMUSIC::DMUS_E_NOSYNTHSINK => 0x8878112E as u32,
            DIRECTMUSIC::DMUS_E_ALREADYOPEN => 0x8878112F as u32,
            DIRECTMUSIC::DMUS_E_ALREADYCLOSED => 0x88781130 as u32,
            DIRECTMUSIC::DMUS_E_SYNTHNOTCONFIGURED => 0x88781131 as u32,
            DIRECTMUSIC::DMUS_E_SYNTHACTIVE => 0x88781132 as u32,
            DIRECTMUSIC::DMUS_E_CANNOTREAD => 0x88781133 as u32,
            DIRECTMUSIC::DMUS_E_DMUSIC_RELEASED => 0x88781134 as u32,
            DIRECTMUSIC::DMUS_E_BUFFER_EMPTY => 0x88781135 as u32,
            DIRECTMUSIC::DMUS_E_BUFFER_FULL => 0x88781136 as u32,
            DIRECTMUSIC::DMUS_E_PORT_NOT_CAPTURE => 0x88781137 as u32,
            DIRECTMUSIC::DMUS_E_PORT_NOT_RENDER => 0x88781138 as u32,
            DIRECTMUSIC::DMUS_E_DSOUND_NOT_SET => 0x88781139 as u32,
            DIRECTMUSIC::DMUS_E_ALREADY_ACTIVATED => 0x8878113A as u32,
            DIRECTMUSIC::DMUS_E_INVALIDBUFFER => 0x8878113B as u32,
            DIRECTMUSIC::DMUS_E_WAVEFORMATNOTSUPPORTED => 0x8878113C as u32,
            DIRECTMUSIC::DMUS_E_SYNTHINACTIVE => 0x8878113D as u32,
            DIRECTMUSIC::DMUS_E_DSOUND_ALREADY_SET => 0x8878113E as u32,
            DIRECTMUSIC::DMUS_E_INVALID_EVENT => 0x8878113F as u32,
            DIRECTMUSIC::DMUS_E_UNSUPPORTED_STREAM => 0x88781150 as u32,
            DIRECTMUSIC::DMUS_E_ALREADY_INITED => 0x88781151 as u32,
            DIRECTMUSIC::DMUS_E_INVALID_BAND => 0x88781152 as u32,
            DIRECTMUSIC::DMUS_E_TRACK_HDR_NOT_FIRST_CK => 0x88781155 as u32,
            DIRECTMUSIC::DMUS_E_TOOL_HDR_NOT_FIRST_CK => 0x88781156 as u32,
            DIRECTMUSIC::DMUS_E_INVALID_TRACK_HDR => 0x88781157 as u32,
            DIRECTMUSIC::DMUS_E_INVALID_TOOL_HDR => 0x88781158 as u32,
            DIRECTMUSIC::DMUS_E_ALL_TOOLS_FAILED => 0x88781159 as u32,
            DIRECTMUSIC::DMUS_E_ALL_TRACKS_FAILED => 0x88781160 as u32,
            DIRECTMUSIC::DMUS_E_NOT_FOUND => 0x88781161 as u32,
            DIRECTMUSIC::DMUS_E_NOT_INIT => 0x88781162 as u32,
            DIRECTMUSIC::DMUS_E_TYPE_DISABLED => 0x88781163 as u32,
            DIRECTMUSIC::DMUS_E_TYPE_UNSUPPORTED => 0x88781164 as u32,
            DIRECTMUSIC::DMUS_E_TIME_PAST => 0x88781165 as u32,
            DIRECTMUSIC::DMUS_E_TRACK_NOT_FOUND => 0x88781166 as u32,
            DIRECTMUSIC::DMUS_E_TRACK_NO_CLOCKTIME_SUPPORT => 0x88781167 as u32,
            DIRECTMUSIC::DMUS_E_NO_MASTER_CLOCK => 0x88781170 as u32,
            DIRECTMUSIC::DMUS_E_LOADER_NOCLASSID => 0x88781180 as u32,
            DIRECTMUSIC::DMUS_E_LOADER_BADPATH => 0x88781181 as u32,
            DIRECTMUSIC::DMUS_E_LOADER_FAILEDOPEN => 0x88781182 as u32,
            DIRECTMUSIC::DMUS_E_LOADER_FORMATNOTSUPPORTED => 0x88781183 as u32,
            DIRECTMUSIC::DMUS_E_LOADER_FAILEDCREATE => 0x88781184 as u32,
            DIRECTMUSIC::DMUS_E_LOADER_OBJECTNOTFOUND => 0x88781185 as u32,
            DIRECTMUSIC::DMUS_E_LOADER_NOFILENAME => 0x88781186 as u32,
            DIRECTMUSIC::DMUS_E_INVALIDFILE => 0x88781200 as u32,
            DIRECTMUSIC::DMUS_E_ALREADY_EXISTS => 0x88781201 as u32,
            DIRECTMUSIC::DMUS_E_OUT_OF_RANGE => 0x88781202 as u32,
            DIRECTMUSIC::DMUS_E_SEGMENT_INIT_FAILED => 0x88781203 as u32,
            DIRECTMUSIC::DMUS_E_ALREADY_SENT => 0x88781204 as u32,
            DIRECTMUSIC::DMUS_E_CANNOT_FREE => 0x88781205 as u32,
            DIRECTMUSIC::DMUS_E_CANNOT_OPEN_PORT => 0x88781206 as u32,
            DIRECTMUSIC::DMUS_E_CANNOT_CONVERT => 0x88781207 as u32,
            DIRECTMUSIC::DMUS_E_DESCEND_CHUNK_FAIL => 0x88781210 as u32,
            DIRECTMUSIC::DMUS_E_NOT_LOADED => 0x88781211 as u32,
            DIRECTMUSIC::DMUS_E_SCRIPT_LANGUAGE_INCOMPATIBLE => 0x88781213 as u32,
            DIRECTMUSIC::DMUS_E_SCRIPT_UNSUPPORTED_VARTYPE => 0x88781214 as u32,
            DIRECTMUSIC::DMUS_E_SCRIPT_ERROR_IN_SCRIPT => 0x88781215 as u32,
            DIRECTMUSIC::DMUS_E_SCRIPT_CANTLOAD_OLEAUT32 => 0x88781216 as u32,
            DIRECTMUSIC::DMUS_E_SCRIPT_LOADSCRIPT_ERROR => 0x88781217 as u32,
            DIRECTMUSIC::DMUS_E_SCRIPT_INVALID_FILE => 0x88781218 as u32,
            DIRECTMUSIC::DMUS_E_INVALID_SCRIPTTRACK => 0x88781219 as u32,
            DIRECTMUSIC::DMUS_E_SCRIPT_VARIABLE_NOT_FOUND => 0x8878121A as u32,
            DIRECTMUSIC::DMUS_E_SCRIPT_ROUTINE_NOT_FOUND => 0x8878121B as u32,
            DIRECTMUSIC::DMUS_E_SCRIPT_CONTENT_READONLY => 0x8878121C as u32,
            DIRECTMUSIC::DMUS_E_SCRIPT_NOT_A_REFERENCE => 0x8878121D as u32,
            DIRECTMUSIC::DMUS_E_SCRIPT_VALUE_NOT_SUPPORTED => 0x8878121E as u32,
            DIRECTMUSIC::DMUS_E_INVALID_SEGMENTTRIGGERTRACK => 0x88781220 as u32,
            DIRECTMUSIC::DMUS_E_INVALID_LYRICSTRACK => 0x88781221 as u32,
            DIRECTMUSIC::DMUS_E_INVALID_PARAMCONTROLTRACK => 0x88781222 as u32,
            DIRECTMUSIC::DMUS_E_AUDIOVBSCRIPT_SYNTAXERROR => 0x88781223 as u32,
            DIRECTMUSIC::DMUS_E_AUDIOVBSCRIPT_RUNTIMEERROR => 0x88781224 as u32,
            DIRECTMUSIC::DMUS_E_AUDIOVBSCRIPT_OPERATIONFAILURE => 0x88781225 as u32,
            DIRECTMUSIC::DMUS_E_AUDIOPATHS_NOT_VALID => 0x88781226 as u32,
            DIRECTMUSIC::DMUS_E_AUDIOPATHS_IN_USE => 0x88781227 as u32,
            DIRECTMUSIC::DMUS_E_NO_AUDIOPATH_CONFIG => 0x88781228 as u32,
            DIRECTMUSIC::DMUS_E_AUDIOPATH_INACTIVE => 0x88781229 as u32,
            DIRECTMUSIC::DMUS_E_AUDIOPATH_NOBUFFER => 0x8878122A as u32,
            DIRECTMUSIC::DMUS_E_AUDIOPATH_NOPORT => 0x8878122B as u32,
            DIRECTMUSIC::DMUS_E_NO_AUDIOPATH => 0x8878122C as u32,
            DIRECTMUSIC::DMUS_E_INVALIDCHUNK => 0x8878122D as u32,
            DIRECTMUSIC::DMUS_E_AUDIOPATH_NOGLOBALFXBUFFER => 0x8878122E as u32,
            DIRECTMUSIC::DMUS_E_INVALID_CONTAINER_OBJECT => 0x8878122F as u32,
        }
    }

    pub fn error(&self) -> RawError {
        return match self {
            DIRECTMUSIC::DSERR_CONTROLUNAVAIL => RawError::Kind(DIRECTMUSIC::DSERR_CONTROLUNAVAIL),
            DIRECTMUSIC::DSERR_INVALIDCALL => RawError::Kind(DIRECTMUSIC::DSERR_INVALIDCALL),
            DIRECTMUSIC::DSERR_PRIOLEVELNEEDED => RawError::Kind(DIRECTMUSIC::DSERR_PRIOLEVELNEEDED),
            DIRECTMUSIC::DSERR_BADFORMAT => RawError::Kind(DIRECTMUSIC::DSERR_BADFORMAT),
            DIRECTMUSIC::DSERR_NODRIVER => RawError::Kind(DIRECTMUSIC::DSERR_NODRIVER),
            DIRECTMUSIC::DSERR_BUFFERLOST => RawError::Kind(DIRECTMUSIC::DSERR_BUFFERLOST),
            DIRECTMUSIC::DSERR_OTHERAPPHASPRIO => RawError::Kind(DIRECTMUSIC::DSERR_OTHERAPPHASPRIO),
            DIRECTMUSIC::DSERR_UNINITIALIZED => RawError::Kind(DIRECTMUSIC::DSERR_UNINITIALIZED),
            DIRECTMUSIC::DSERR_DS8_REQUIRED => RawError::Kind(DIRECTMUSIC::DSERR_DS8_REQUIRED),
            DIRECTMUSIC::DMUS_E_DRIVER_FAILED => RawError::Kind(DIRECTMUSIC::DMUS_E_DRIVER_FAILED),
            DIRECTMUSIC::DMUS_E_PORTS_OPEN => RawError::Kind(DIRECTMUSIC::DMUS_E_PORTS_OPEN),
            DIRECTMUSIC::DMUS_E_DEVICE_IN_USE => RawError::Kind(DIRECTMUSIC::DMUS_E_DEVICE_IN_USE),
            DIRECTMUSIC::DMUS_E_INSUFFICIENTBUFFER => RawError::Kind(DIRECTMUSIC::DMUS_E_INSUFFICIENTBUFFER),
            DIRECTMUSIC::DMUS_E_BUFFERNOTSET => RawError::Kind(DIRECTMUSIC::DMUS_E_BUFFERNOTSET),
            DIRECTMUSIC::DMUS_E_BUFFERNOTAVAILABLE => RawError::Kind(DIRECTMUSIC::DMUS_E_BUFFERNOTAVAILABLE),
            DIRECTMUSIC::DMUS_E_NOTADLSCOL => RawError::Kind(DIRECTMUSIC::DMUS_E_NOTADLSCOL),
            DIRECTMUSIC::DMUS_E_INVALIDOFFSET => RawError::Kind(DIRECTMUSIC::DMUS_E_INVALIDOFFSET),
            DIRECTMUSIC::DMUS_E_ALREADY_LOADED => RawError::Kind(DIRECTMUSIC::DMUS_E_ALREADY_LOADED),
            DIRECTMUSIC::DMUS_E_INVALIDPOS => RawError::Kind(DIRECTMUSIC::DMUS_E_INVALIDPOS),
            DIRECTMUSIC::DMUS_E_INVALIDPATCH => RawError::Kind(DIRECTMUSIC::DMUS_E_INVALIDPATCH),
            DIRECTMUSIC::DMUS_E_CANNOTSEEK => RawError::Kind(DIRECTMUSIC::DMUS_E_CANNOTSEEK),
            DIRECTMUSIC::DMUS_E_CANNOTWRITE => RawError::Kind(DIRECTMUSIC::DMUS_E_CANNOTWRITE),
            DIRECTMUSIC::DMUS_E_CHUNKNOTFOUND => RawError::Kind(DIRECTMUSIC::DMUS_E_CHUNKNOTFOUND),
            DIRECTMUSIC::DMUS_E_INVALID_DOWNLOADID => RawError::Kind(DIRECTMUSIC::DMUS_E_INVALID_DOWNLOADID),
            DIRECTMUSIC::DMUS_E_NOT_DOWNLOADED_TO_PORT => RawError::Kind(DIRECTMUSIC::DMUS_E_NOT_DOWNLOADED_TO_PORT),
            DIRECTMUSIC::DMUS_E_ALREADY_DOWNLOADED => RawError::Kind(DIRECTMUSIC::DMUS_E_ALREADY_DOWNLOADED),
            DIRECTMUSIC::DMUS_E_UNKNOWN_PROPERTY => RawError::Kind(DIRECTMUSIC::DMUS_E_UNKNOWN_PROPERTY),
            DIRECTMUSIC::DMUS_E_SET_UNSUPPORTED => RawError::Kind(DIRECTMUSIC::DMUS_E_SET_UNSUPPORTED),
            DIRECTMUSIC::DMUS_E_GET_UNSUPPORTED => RawError::Kind(DIRECTMUSIC::DMUS_E_GET_UNSUPPORTED),
            DIRECTMUSIC::DMUS_E_NOTMONO => RawError::Kind(DIRECTMUSIC::DMUS_E_NOTMONO),
            DIRECTMUSIC::DMUS_E_BADARTICULATION => RawError::Kind(DIRECTMUSIC::DMUS_E_BADARTICULATION),
            DIRECTMUSIC::DMUS_E_BADINSTRUMENT => RawError::Kind(DIRECTMUSIC::DMUS_E_BADINSTRUMENT),
            DIRECTMUSIC::DMUS_E_BADWAVELINK => RawError::Kind(DIRECTMUSIC::DMUS_E_BADWAVELINK),
            DIRECTMUSIC::DMUS_E_NOARTICULATION => RawError::Kind(DIRECTMUSIC::DMUS_E_NOARTICULATION),
            DIRECTMUSIC::DMUS_E_NOTPCM => RawError::Kind(DIRECTMUSIC::DMUS_E_NOTPCM),
            DIRECTMUSIC::DMUS_E_BADWAVE => RawError::Kind(DIRECTMUSIC::DMUS_E_BADWAVE),
            DIRECTMUSIC::DMUS_E_BADOFFSETTABLE => RawError::Kind(DIRECTMUSIC::DMUS_E_BADOFFSETTABLE),
            DIRECTMUSIC::DMUS_E_UNKNOWNDOWNLOAD => RawError::Kind(DIRECTMUSIC::DMUS_E_UNKNOWNDOWNLOAD),
            DIRECTMUSIC::DMUS_E_NOSYNTHSINK => RawError::Kind(DIRECTMUSIC::DMUS_E_NOSYNTHSINK),
            DIRECTMUSIC::DMUS_E_ALREADYOPEN => RawError::Kind(DIRECTMUSIC::DMUS_E_ALREADYOPEN),
            DIRECTMUSIC::DMUS_E_ALREADYCLOSED => RawError::Kind(DIRECTMUSIC::DMUS_E_ALREADYCLOSED),
            DIRECTMUSIC::DMUS_E_SYNTHNOTCONFIGURED => RawError::Kind(DIRECTMUSIC::DMUS_E_SYNTHNOTCONFIGURED),
            DIRECTMUSIC::DMUS_E_SYNTHACTIVE => RawError::Kind(DIRECTMUSIC::DMUS_E_SYNTHACTIVE),
            DIRECTMUSIC::DMUS_E_CANNOTREAD => RawError::Kind(DIRECTMUSIC::DMUS_E_CANNOTREAD),
            DIRECTMUSIC::DMUS_E_DMUSIC_RELEASED => RawError::Kind(DIRECTMUSIC::DMUS_E_DMUSIC_RELEASED),
            DIRECTMUSIC::DMUS_E_BUFFER_EMPTY => RawError::Kind(DIRECTMUSIC::DMUS_E_BUFFER_EMPTY),
            DIRECTMUSIC::DMUS_E_BUFFER_FULL => RawError::Kind(DIRECTMUSIC::DMUS_E_BUFFER_FULL),
            DIRECTMUSIC::DMUS_E_PORT_NOT_CAPTURE => RawError::Kind(DIRECTMUSIC::DMUS_E_PORT_NOT_CAPTURE),
            DIRECTMUSIC::DMUS_E_PORT_NOT_RENDER => RawError::Kind(DIRECTMUSIC::DMUS_E_PORT_NOT_RENDER),
            DIRECTMUSIC::DMUS_E_DSOUND_NOT_SET => RawError::Kind(DIRECTMUSIC::DMUS_E_DSOUND_NOT_SET),
            DIRECTMUSIC::DMUS_E_ALREADY_ACTIVATED => RawError::Kind(DIRECTMUSIC::DMUS_E_ALREADY_ACTIVATED),
            DIRECTMUSIC::DMUS_E_INVALIDBUFFER => RawError::Kind(DIRECTMUSIC::DMUS_E_INVALIDBUFFER),
            DIRECTMUSIC::DMUS_E_WAVEFORMATNOTSUPPORTED => RawError::Kind(DIRECTMUSIC::DMUS_E_WAVEFORMATNOTSUPPORTED),
            DIRECTMUSIC::DMUS_E_SYNTHINACTIVE => RawError::Kind(DIRECTMUSIC::DMUS_E_SYNTHINACTIVE),
            DIRECTMUSIC::DMUS_E_DSOUND_ALREADY_SET => RawError::Kind(DIRECTMUSIC::DMUS_E_DSOUND_ALREADY_SET),
            DIRECTMUSIC::DMUS_E_INVALID_EVENT => RawError::Kind(DIRECTMUSIC::DMUS_E_INVALID_EVENT),
            DIRECTMUSIC::DMUS_E_UNSUPPORTED_STREAM => RawError::Kind(DIRECTMUSIC::DMUS_E_UNSUPPORTED_STREAM),
            DIRECTMUSIC::DMUS_E_ALREADY_INITED => RawError::Kind(DIRECTMUSIC::DMUS_E_ALREADY_INITED),
            DIRECTMUSIC::DMUS_E_INVALID_BAND => RawError::Kind(DIRECTMUSIC::DMUS_E_INVALID_BAND),
            DIRECTMUSIC::DMUS_E_TRACK_HDR_NOT_FIRST_CK => RawError::Kind(DIRECTMUSIC::DMUS_E_TRACK_HDR_NOT_FIRST_CK),
            DIRECTMUSIC::DMUS_E_TOOL_HDR_NOT_FIRST_CK => RawError::Kind(DIRECTMUSIC::DMUS_E_TOOL_HDR_NOT_FIRST_CK),
            DIRECTMUSIC::DMUS_E_INVALID_TRACK_HDR => RawError::Kind(DIRECTMUSIC::DMUS_E_INVALID_TRACK_HDR),
            DIRECTMUSIC::DMUS_E_INVALID_TOOL_HDR => RawError::Kind(DIRECTMUSIC::DMUS_E_INVALID_TOOL_HDR),
            DIRECTMUSIC::DMUS_E_ALL_TOOLS_FAILED => RawError::Kind(DIRECTMUSIC::DMUS_E_ALL_TOOLS_FAILED),
            DIRECTMUSIC::DMUS_E_ALL_TRACKS_FAILED => RawError::Kind(DIRECTMUSIC::DMUS_E_ALL_TRACKS_FAILED),
            DIRECTMUSIC::DMUS_E_NOT_FOUND => RawError::Kind(DIRECTMUSIC::DMUS_E_NOT_FOUND),
            DIRECTMUSIC::DMUS_E_NOT_INIT => RawError::Kind(DIRECTMUSIC::DMUS_E_NOT_INIT),
            DIRECTMUSIC::DMUS_E_TYPE_DISABLED => RawError::Kind(DIRECTMUSIC::DMUS_E_TYPE_DISABLED),
            DIRECTMUSIC::DMUS_E_TYPE_UNSUPPORTED => RawError::Kind(DIRECTMUSIC::DMUS_E_TYPE_UNSUPPORTED),
            DIRECTMUSIC::DMUS_E_TIME_PAST => RawError::Kind(DIRECTMUSIC::DMUS_E_TIME_PAST),
            DIRECTMUSIC::DMUS_E_TRACK_NOT_FOUND => RawError::Kind(DIRECTMUSIC::DMUS_E_TRACK_NOT_FOUND),
            DIRECTMUSIC::DMUS_E_TRACK_NO_CLOCKTIME_SUPPORT => RawError::Kind(DIRECTMUSIC::DMUS_E_TRACK_NO_CLOCKTIME_SUPPORT),
            DIRECTMUSIC::DMUS_E_NO_MASTER_CLOCK => RawError::Kind(DIRECTMUSIC::DMUS_E_NO_MASTER_CLOCK),
            DIRECTMUSIC::DMUS_E_LOADER_NOCLASSID => RawError::Kind(DIRECTMUSIC::DMUS_E_LOADER_NOCLASSID),
            DIRECTMUSIC::DMUS_E_LOADER_BADPATH => RawError::Kind(DIRECTMUSIC::DMUS_E_LOADER_BADPATH),
            DIRECTMUSIC::DMUS_E_LOADER_FAILEDOPEN => RawError::Kind(DIRECTMUSIC::DMUS_E_LOADER_FAILEDOPEN),
            DIRECTMUSIC::DMUS_E_LOADER_FORMATNOTSUPPORTED => RawError::Kind(DIRECTMUSIC::DMUS_E_LOADER_FORMATNOTSUPPORTED),
            DIRECTMUSIC::DMUS_E_LOADER_FAILEDCREATE => RawError::Kind(DIRECTMUSIC::DMUS_E_LOADER_FAILEDCREATE),
            DIRECTMUSIC::DMUS_E_LOADER_OBJECTNOTFOUND => RawError::Kind(DIRECTMUSIC::DMUS_E_LOADER_OBJECTNOTFOUND),
            DIRECTMUSIC::DMUS_E_LOADER_NOFILENAME => RawError::Kind(DIRECTMUSIC::DMUS_E_LOADER_NOFILENAME),
            DIRECTMUSIC::DMUS_E_INVALIDFILE => RawError::Kind(DIRECTMUSIC::DMUS_E_INVALIDFILE),
            DIRECTMUSIC::DMUS_E_ALREADY_EXISTS => RawError::Kind(DIRECTMUSIC::DMUS_E_ALREADY_EXISTS),
            DIRECTMUSIC::DMUS_E_OUT_OF_RANGE => RawError::Kind(DIRECTMUSIC::DMUS_E_OUT_OF_RANGE),
            DIRECTMUSIC::DMUS_E_SEGMENT_INIT_FAILED => RawError::Kind(DIRECTMUSIC::DMUS_E_SEGMENT_INIT_FAILED),
            DIRECTMUSIC::DMUS_E_ALREADY_SENT => RawError::Kind(DIRECTMUSIC::DMUS_E_ALREADY_SENT),
            DIRECTMUSIC::DMUS_E_CANNOT_FREE => RawError::Kind(DIRECTMUSIC::DMUS_E_CANNOT_FREE),
            DIRECTMUSIC::DMUS_E_CANNOT_OPEN_PORT => RawError::Kind(DIRECTMUSIC::DMUS_E_CANNOT_OPEN_PORT),
            DIRECTMUSIC::DMUS_E_CANNOT_CONVERT => RawError::Kind(DIRECTMUSIC::DMUS_E_CANNOT_CONVERT),
            DIRECTMUSIC::DMUS_E_DESCEND_CHUNK_FAIL => RawError::Kind(DIRECTMUSIC::DMUS_E_DESCEND_CHUNK_FAIL),
            DIRECTMUSIC::DMUS_E_NOT_LOADED => RawError::Kind(DIRECTMUSIC::DMUS_E_NOT_LOADED),
            DIRECTMUSIC::DMUS_E_SCRIPT_LANGUAGE_INCOMPATIBLE => RawError::Kind(DIRECTMUSIC::DMUS_E_SCRIPT_LANGUAGE_INCOMPATIBLE),
            DIRECTMUSIC::DMUS_E_SCRIPT_UNSUPPORTED_VARTYPE => RawError::Kind(DIRECTMUSIC::DMUS_E_SCRIPT_UNSUPPORTED_VARTYPE),
            DIRECTMUSIC::DMUS_E_SCRIPT_ERROR_IN_SCRIPT => RawError::Kind(DIRECTMUSIC::DMUS_E_SCRIPT_ERROR_IN_SCRIPT),
            DIRECTMUSIC::DMUS_E_SCRIPT_CANTLOAD_OLEAUT32 => RawError::Kind(DIRECTMUSIC::DMUS_E_SCRIPT_CANTLOAD_OLEAUT32),
            DIRECTMUSIC::DMUS_E_SCRIPT_LOADSCRIPT_ERROR => RawError::Kind(DIRECTMUSIC::DMUS_E_SCRIPT_LOADSCRIPT_ERROR),
            DIRECTMUSIC::DMUS_E_SCRIPT_INVALID_FILE => RawError::Kind(DIRECTMUSIC::DMUS_E_SCRIPT_INVALID_FILE),
            DIRECTMUSIC::DMUS_E_INVALID_SCRIPTTRACK => RawError::Kind(DIRECTMUSIC::DMUS_E_INVALID_SCRIPTTRACK),
            DIRECTMUSIC::DMUS_E_SCRIPT_VARIABLE_NOT_FOUND => RawError::Kind(DIRECTMUSIC::DMUS_E_SCRIPT_VARIABLE_NOT_FOUND),
            DIRECTMUSIC::DMUS_E_SCRIPT_ROUTINE_NOT_FOUND => RawError::Kind(DIRECTMUSIC::DMUS_E_SCRIPT_ROUTINE_NOT_FOUND),
            DIRECTMUSIC::DMUS_E_SCRIPT_CONTENT_READONLY => RawError::Kind(DIRECTMUSIC::DMUS_E_SCRIPT_CONTENT_READONLY),
            DIRECTMUSIC::DMUS_E_SCRIPT_NOT_A_REFERENCE => RawError::Kind(DIRECTMUSIC::DMUS_E_SCRIPT_NOT_A_REFERENCE),
            DIRECTMUSIC::DMUS_E_SCRIPT_VALUE_NOT_SUPPORTED => RawError::Kind(DIRECTMUSIC::DMUS_E_SCRIPT_VALUE_NOT_SUPPORTED),
            DIRECTMUSIC::DMUS_E_INVALID_SEGMENTTRIGGERTRACK => RawError::Kind(DIRECTMUSIC::DMUS_E_INVALID_SEGMENTTRIGGERTRACK),
            DIRECTMUSIC::DMUS_E_INVALID_LYRICSTRACK => RawError::Kind(DIRECTMUSIC::DMUS_E_INVALID_LYRICSTRACK),
            DIRECTMUSIC::DMUS_E_INVALID_PARAMCONTROLTRACK => RawError::Kind(DIRECTMUSIC::DMUS_E_INVALID_PARAMCONTROLTRACK),
            DIRECTMUSIC::DMUS_E_AUDIOVBSCRIPT_SYNTAXERROR => RawError::Kind(DIRECTMUSIC::DMUS_E_AUDIOVBSCRIPT_SYNTAXERROR),
            DIRECTMUSIC::DMUS_E_AUDIOVBSCRIPT_RUNTIMEERROR => RawError::Kind(DIRECTMUSIC::DMUS_E_AUDIOVBSCRIPT_RUNTIMEERROR),
            DIRECTMUSIC::DMUS_E_AUDIOVBSCRIPT_OPERATIONFAILURE => RawError::Kind(DIRECTMUSIC::DMUS_E_AUDIOVBSCRIPT_OPERATIONFAILURE),
            DIRECTMUSIC::DMUS_E_AUDIOPATHS_NOT_VALID => RawError::Kind(DIRECTMUSIC::DMUS_E_AUDIOPATHS_NOT_VALID),
            DIRECTMUSIC::DMUS_E_AUDIOPATHS_IN_USE => RawError::Kind(DIRECTMUSIC::DMUS_E_AUDIOPATHS_IN_USE),
            DIRECTMUSIC::DMUS_E_NO_AUDIOPATH_CONFIG => RawError::Kind(DIRECTMUSIC::DMUS_E_NO_AUDIOPATH_CONFIG),
            DIRECTMUSIC::DMUS_E_AUDIOPATH_INACTIVE => RawError::Kind(DIRECTMUSIC::DMUS_E_AUDIOPATH_INACTIVE),
            DIRECTMUSIC::DMUS_E_AUDIOPATH_NOBUFFER => RawError::Kind(DIRECTMUSIC::DMUS_E_AUDIOPATH_NOBUFFER),
            DIRECTMUSIC::DMUS_E_AUDIOPATH_NOPORT => RawError::Kind(DIRECTMUSIC::DMUS_E_AUDIOPATH_NOPORT),
            DIRECTMUSIC::DMUS_E_NO_AUDIOPATH => RawError::Kind(DIRECTMUSIC::DMUS_E_NO_AUDIOPATH),
            DIRECTMUSIC::DMUS_E_INVALIDCHUNK => RawError::Kind(DIRECTMUSIC::DMUS_E_INVALIDCHUNK),
            DIRECTMUSIC::DMUS_E_AUDIOPATH_NOGLOBALFXBUFFER => RawError::Kind(DIRECTMUSIC::DMUS_E_AUDIOPATH_NOGLOBALFXBUFFER),
            DIRECTMUSIC::DMUS_E_INVALID_CONTAINER_OBJECT => RawError::Kind(DIRECTMUSIC::DMUS_E_INVALID_CONTAINER_OBJECT),
        }
    }

    pub fn description(&self) -> &'static str {
        return match self {
            DIRECTMUSIC::DSERR_CONTROLUNAVAIL => "The requested control is not available.",
            DIRECTMUSIC::DSERR_INVALIDCALL => "The call is not valid for the current state of this object.",
            DIRECTMUSIC::DSERR_PRIOLEVELNEEDED => "The function requires a higher priority level.",
            DIRECTMUSIC::DSERR_BADFORMAT => "The specified wave format is not supported.",
            DIRECTMUSIC::DSERR_NODRIVER => "No sound driver is available for use.",
            DIRECTMUSIC::DSERR_BUFFERLOST => "Buffer memory has been lost, and must be restored.",
            DIRECTMUSIC::DSERR_OTHERAPPHASPRIO => "Another dsound app has focus, preventing this call from succeeding.",
            DIRECTMUSIC::DSERR_UNINITIALIZED => "This object has not been initialized.",
            DIRECTMUSIC::DSERR_DS8_REQUIRED => "Attempted to use DirectSound 8+ functionality on an older DirectSound object",
            DIRECTMUSIC::DMUS_E_DRIVER_FAILED => "An unexpected error was returned from a device driver, indicating possible failure of the driver or hardware.",
            DIRECTMUSIC::DMUS_E_PORTS_OPEN => "The requested operation cannot be performed while there are instantiated ports in any process in the system.",
            DIRECTMUSIC::DMUS_E_DEVICE_IN_USE => "The requested device is already in use (possibly by a non-DirectMusic client), and cannot be opened again.",
            DIRECTMUSIC::DMUS_E_INSUFFICIENTBUFFER => "Buffer is not large enough for the requested operation.",
            DIRECTMUSIC::DMUS_E_BUFFERNOTSET => "No buffer was prepared for the download data.",
            DIRECTMUSIC::DMUS_E_BUFFERNOTAVAILABLE => "Download failed due to inability to access or create a download buffer.",
            DIRECTMUSIC::DMUS_E_NOTADLSCOL => "Error parsing DLS collection. File is corrupt.",
            DIRECTMUSIC::DMUS_E_INVALIDOFFSET => "Wave chunks in DLS collection file are at incorrect offsets.",
            DIRECTMUSIC::DMUS_E_ALREADY_LOADED => "Attempted to load a DLS collection that has already been loaded.",
            DIRECTMUSIC::DMUS_E_INVALIDPOS => "Error reading wave data from DLS collection. Indicates a bad file.",
            DIRECTMUSIC::DMUS_E_INVALIDPATCH => "There is no instrument in the collection that matches the specified patch number.",
            DIRECTMUSIC::DMUS_E_CANNOTSEEK => "The IStream* doesn't support Seek().",
            DIRECTMUSIC::DMUS_E_CANNOTWRITE => "The IStream* doesn't support Write().",
            DIRECTMUSIC::DMUS_E_CHUNKNOTFOUND => "A required RIFF chunk could not be found while parsing a file.",
            DIRECTMUSIC::DMUS_E_INVALID_DOWNLOADID => "An invalid download id was used in the process of creating a download buffer.",
            DIRECTMUSIC::DMUS_E_NOT_DOWNLOADED_TO_PORT => "Attempted to unload an object that was not downloaded or that was previously unloaded.",
            DIRECTMUSIC::DMUS_E_ALREADY_DOWNLOADED => "Buffer was already downloaded to synth.",
            DIRECTMUSIC::DMUS_E_UNKNOWN_PROPERTY => "The specified property item was not recognized by the target object.",
            DIRECTMUSIC::DMUS_E_SET_UNSUPPORTED => "The specified property item may not be set on the target object.",
            DIRECTMUSIC::DMUS_E_GET_UNSUPPORTED => "The specified property item may not be retrieved from the target object.",
            DIRECTMUSIC::DMUS_E_NOTMONO => "Wave chunk has more than one interleaved channel. DLS format requires MONO.",
            DIRECTMUSIC::DMUS_E_BADARTICULATION => "Invalid articulation chunk in DLS collection.",
            DIRECTMUSIC::DMUS_E_BADINSTRUMENT => "Invalid instrument chunk in DLS collection.",
            DIRECTMUSIC::DMUS_E_BADWAVELINK => "Wavelink chunk in DLS collection points to invalid wave.",
            DIRECTMUSIC::DMUS_E_NOARTICULATION => "Articulation missing from instrument in DLS collection.",
            DIRECTMUSIC::DMUS_E_NOTPCM => "Downoaded DLS wave is not in PCM format.",
            DIRECTMUSIC::DMUS_E_BADWAVE => "Bad wave chunk in DLS collection.",
            DIRECTMUSIC::DMUS_E_BADOFFSETTABLE => "Offset Table for download buffer has errors.",
            DIRECTMUSIC::DMUS_E_UNKNOWNDOWNLOAD => "Attempted to download unknown data type.",
            DIRECTMUSIC::DMUS_E_NOSYNTHSINK => "An operation could not be completed because no sink was connected to the synthesizer.",
            DIRECTMUSIC::DMUS_E_ALREADYOPEN => "An attempt was made to open the software synthesizer while it was already open.",
            DIRECTMUSIC::DMUS_E_ALREADYCLOSED => "An attempt was made to close the software synthesizer while it was already closed.",
            DIRECTMUSIC::DMUS_E_SYNTHNOTCONFIGURED => "The operation could not be completed because the software synthesizer has not yet been fully configured.",
            DIRECTMUSIC::DMUS_E_SYNTHACTIVE => "The operation cannot be carried out while the synthesizer is active.",
            DIRECTMUSIC::DMUS_E_CANNOTREAD => "An error occurred while attempting to read from the IStream* object.",
            DIRECTMUSIC::DMUS_E_DMUSIC_RELEASED => "The operation cannot be performed because the final instance of the DirectMusic object was released. Ports cannot be used after final release of the DirectMusic object.",
            DIRECTMUSIC::DMUS_E_BUFFER_EMPTY => "There was no data in the referenced buffer.",
            DIRECTMUSIC::DMUS_E_BUFFER_FULL => "There is insufficient space to insert the specified event into the buffer.",
            DIRECTMUSIC::DMUS_E_PORT_NOT_CAPTURE => "The specified operation could not be carried out because the port is a capture port.",
            DIRECTMUSIC::DMUS_E_PORT_NOT_RENDER => "The specified operation could not be carried out because the port is a render port.",
            DIRECTMUSIC::DMUS_E_DSOUND_NOT_SET => "The port could not be created because no DirectSound instance has been specified. Specify a DirectSound interface via the IDirectMusic::SetDirectSound method; pass NULL to have DirectMusic manage usage of DirectSound.",
            DIRECTMUSIC::DMUS_E_ALREADY_ACTIVATED => "The operation cannot be carried out while the port is active.",
            DIRECTMUSIC::DMUS_E_INVALIDBUFFER => "An invalid DirectSound buffer was passed to the port.",
            DIRECTMUSIC::DMUS_E_WAVEFORMATNOTSUPPORTED => "An invalid buffer format was handed to the synth sink.",
            DIRECTMUSIC::DMUS_E_SYNTHINACTIVE => "The operation cannot be carried out while the synthesizer is inactive.",
            DIRECTMUSIC::DMUS_E_DSOUND_ALREADY_SET => "IDirectMusic::SetDirectSound has already been called. It may not be changed while in use.",
            DIRECTMUSIC::DMUS_E_INVALID_EVENT => "The given event is invalid (either it is not a valid MIDI message or it makes use of running status). The event cannot be packed into the buffer.",
            DIRECTMUSIC::DMUS_E_UNSUPPORTED_STREAM => "The IStream* object does not contain data supported by the loading object.",
            DIRECTMUSIC::DMUS_E_ALREADY_INITED => "The object has already been initialized.",
            DIRECTMUSIC::DMUS_E_INVALID_BAND => "The file does not contain a valid band.",
            DIRECTMUSIC::DMUS_E_TRACK_HDR_NOT_FIRST_CK => "The IStream* object's data does not have a track header as the first chunk. Therefore, it can't be read by the segment object.",
            DIRECTMUSIC::DMUS_E_TOOL_HDR_NOT_FIRST_CK => "The IStream* object's data does not have a tool header as the first chunk. Therefore, it can't be read by the graph object.",
            DIRECTMUSIC::DMUS_E_INVALID_TRACK_HDR => "The IStream* object's data contains an invalid track header (ckid is 0 and fccType is NULL). Therefore, it can't be read by the segment object.",
            DIRECTMUSIC::DMUS_E_INVALID_TOOL_HDR => "The IStream* object's data contains an invalid tool header (ckid is 0 and fccType is NULL). Therefore, it can't be read by the graph object.",
            DIRECTMUSIC::DMUS_E_ALL_TOOLS_FAILED => "The graph object was unable to load all tools from the IStream* object data. This may be due to errors in the stream, or the tools being incorrectly registered on the client.",
            DIRECTMUSIC::DMUS_E_ALL_TRACKS_FAILED => "The segment object was unable to load all tracks from the IStream* object data. This may be due to errors in the stream, or the tracks being incorrectly registered on the client.",
            DIRECTMUSIC::DMUS_E_NOT_FOUND => "The requested item was not contained by the object.",
            DIRECTMUSIC::DMUS_E_NOT_INIT => "A required object is not initialized or failed to initialize.",
            DIRECTMUSIC::DMUS_E_TYPE_DISABLED => "The requested parameter type is currently disabled. Parameter types may be enabled and disabled by certain calls to SetParam().",
            DIRECTMUSIC::DMUS_E_TYPE_UNSUPPORTED => "The requested parameter type is not supported on the object.",
            DIRECTMUSIC::DMUS_E_TIME_PAST => "The specified time is in the past, and the operation can not succeed.",
            DIRECTMUSIC::DMUS_E_TRACK_NOT_FOUND => "The requested track is not contained by the segment.",
            DIRECTMUSIC::DMUS_E_TRACK_NO_CLOCKTIME_SUPPORT => "The track does not support clock time playback or getparam.",
            DIRECTMUSIC::DMUS_E_NO_MASTER_CLOCK => "There is no master clock in the performance. Be sure to call IDirectMusicPerformance::Init().",
            DIRECTMUSIC::DMUS_E_LOADER_NOCLASSID => "The class id field is required and is missing in the DMUS_OBJECTDESC.",
            DIRECTMUSIC::DMUS_E_LOADER_BADPATH => "The specified file path is invalid.",
            DIRECTMUSIC::DMUS_E_LOADER_FAILEDOPEN => "File open failed.",
            DIRECTMUSIC::DMUS_E_LOADER_FORMATNOTSUPPORTED => "Search data type is not supported.",
            DIRECTMUSIC::DMUS_E_LOADER_FAILEDCREATE => "Unable to find or create object.",
            DIRECTMUSIC::DMUS_E_LOADER_OBJECTNOTFOUND => "Object was not found.",
            DIRECTMUSIC::DMUS_E_LOADER_NOFILENAME => "The file name is missing from the DMUS_OBJECTDESC.",
            DIRECTMUSIC::DMUS_E_INVALIDFILE => "The specified file is not a valid file.",
            DIRECTMUSIC::DMUS_E_ALREADY_EXISTS => "The tool is already contained in the graph. Create a new instance.",
            DIRECTMUSIC::DMUS_E_OUT_OF_RANGE => "Value is out of range.",
            DIRECTMUSIC::DMUS_E_SEGMENT_INIT_FAILED => "Segment initialization failed.",
            DIRECTMUSIC::DMUS_E_ALREADY_SENT => "The DMUS_PMSG has already been sent to the performance object via IDirectMusicPerformance::SendPMsg().",
            DIRECTMUSIC::DMUS_E_CANNOT_FREE => "The DMUS_PMSG was either not allocated by the performance via IDirectMusicPerformance::AllocPMsg(), or it was already freed via IDirectMusicPerformance::FreePMsg().",
            DIRECTMUSIC::DMUS_E_CANNOT_OPEN_PORT => "The default system port could not be opened.",
            DIRECTMUSIC::DMUS_E_CANNOT_CONVERT => "A call to MIDIToMusic() or MusicToMIDI() resulted in an error because the requested conversion could not happen. This usually occurs when the provided DMUS_CHORD_KEY structure has an invalid chord or scale pattern.",
            DIRECTMUSIC::DMUS_E_DESCEND_CHUNK_FAIL => "The end of the file was reached before the specified chunk was found.",
            DIRECTMUSIC::DMUS_E_NOT_LOADED => "An attempt to use this object failed because the object has not been loaded.",
            DIRECTMUSIC::DMUS_E_SCRIPT_LANGUAGE_INCOMPATIBLE => "The activeX scripting engine for the script's language is not compatible with DirectMusic.",
            DIRECTMUSIC::DMUS_E_SCRIPT_UNSUPPORTED_VARTYPE => "A variant was used that had a type that is not supported by DirectMusic.",
            DIRECTMUSIC::DMUS_E_SCRIPT_ERROR_IN_SCRIPT => "An error was encountered while parsing or executing the script.",
            DIRECTMUSIC::DMUS_E_SCRIPT_CANTLOAD_OLEAUT32 => "Loading of oleaut32.dll failed.",
            DIRECTMUSIC::DMUS_E_SCRIPT_LOADSCRIPT_ERROR => "An error occurred while parsing a script loaded using LoadScript. The script being loaded contains an error.",
            DIRECTMUSIC::DMUS_E_SCRIPT_INVALID_FILE => "The script file is invalid.",
            DIRECTMUSIC::DMUS_E_INVALID_SCRIPTTRACK => "The file contains an invalid script track.",
            DIRECTMUSIC::DMUS_E_SCRIPT_VARIABLE_NOT_FOUND => "The script does not contain a variable with the specified name.",
            DIRECTMUSIC::DMUS_E_SCRIPT_ROUTINE_NOT_FOUND => "The script does not contain a routine with the specified name.",
            DIRECTMUSIC::DMUS_E_SCRIPT_CONTENT_READONLY => "Attempted to set variables for content referenced or embedded in a script.",
            DIRECTMUSIC::DMUS_E_SCRIPT_NOT_A_REFERENCE => "Attempt was made to set a script's variable by reference to a value that was not an object type.",
            DIRECTMUSIC::DMUS_E_SCRIPT_VALUE_NOT_SUPPORTED => "Attempt was made to set a script's variable by value to an object that does not support a default value property.",
            DIRECTMUSIC::DMUS_E_INVALID_SEGMENTTRIGGERTRACK => "The file contains an invalid segment trigger track.",
            DIRECTMUSIC::DMUS_E_INVALID_LYRICSTRACK => "The file contains an invalid lyrics track.",
            DIRECTMUSIC::DMUS_E_INVALID_PARAMCONTROLTRACK => "The file contains an invalid parameter control track.",
            DIRECTMUSIC::DMUS_E_AUDIOVBSCRIPT_SYNTAXERROR => "A script written in AudioVBScript could not be read because it contained a statement that is not allowed by the AudioVBScript language.",
            DIRECTMUSIC::DMUS_E_AUDIOVBSCRIPT_RUNTIMEERROR => "A script routine written in AudioVBScript failed because an invalid operation occurred.",
            DIRECTMUSIC::DMUS_E_AUDIOVBSCRIPT_OPERATIONFAILURE => "A script routine written in AudioVBScript failed because a function outside of a script failed to complete.",
            DIRECTMUSIC::DMUS_E_AUDIOPATHS_NOT_VALID => "Audio paths are invalid because pchannels have been set.",
            DIRECTMUSIC::DMUS_E_AUDIOPATHS_IN_USE => "Pchannels are invalid because audio paths have been set.",
            DIRECTMUSIC::DMUS_E_NO_AUDIOPATH_CONFIG => "The specified segment has no embedded audio path configuration.",
            DIRECTMUSIC::DMUS_E_AUDIOPATH_INACTIVE => "An audiopath is inactive.",
            DIRECTMUSIC::DMUS_E_AUDIOPATH_NOBUFFER => "An audiopath failed to create because a requested buffer could not be created.",
            DIRECTMUSIC::DMUS_E_AUDIOPATH_NOPORT => "An audiopath could not be used for playback because it lacked port assignments.",
            DIRECTMUSIC::DMUS_E_NO_AUDIOPATH => "Attempted to play a segment in audiopath mode when there was no audiopath.",
            DIRECTMUSIC::DMUS_E_INVALIDCHUNK => "Invalid data was found in a RIFF file chunk.",
            DIRECTMUSIC::DMUS_E_AUDIOPATH_NOGLOBALFXBUFFER => "Attempted to create an audiopath that sends to a nonexistent global effects buffer.",
            DIRECTMUSIC::DMUS_E_INVALID_CONTAINER_OBJECT => "The file does not contain a valid container object.",
        }
    }

    pub fn from_name(name: &str) -> DIRECTMUSIC {
        return match name {
            "DSERR_CONTROLUNAVAIL" => DIRECTMUSIC::DSERR_CONTROLUNAVAIL,
            "DSERR_INVALIDCALL" => DIRECTMUSIC::DSERR_INVALIDCALL,
            "DSERR_PRIOLEVELNEEDED" => DIRECTMUSIC::DSERR_PRIOLEVELNEEDED,
            "DSERR_BADFORMAT" => DIRECTMUSIC::DSERR_BADFORMAT,
            "DSERR_NODRIVER" => DIRECTMUSIC::DSERR_NODRIVER,
            "DSERR_BUFFERLOST" => DIRECTMUSIC::DSERR_BUFFERLOST,
            "DSERR_OTHERAPPHASPRIO" => DIRECTMUSIC::DSERR_OTHERAPPHASPRIO,
            "DSERR_UNINITIALIZED" => DIRECTMUSIC::DSERR_UNINITIALIZED,
            "DSERR_DS8_REQUIRED" => DIRECTMUSIC::DSERR_DS8_REQUIRED,
            "DMUS_E_DRIVER_FAILED" => DIRECTMUSIC::DMUS_E_DRIVER_FAILED,
            "DMUS_E_PORTS_OPEN" => DIRECTMUSIC::DMUS_E_PORTS_OPEN,
            "DMUS_E_DEVICE_IN_USE" => DIRECTMUSIC::DMUS_E_DEVICE_IN_USE,
            "DMUS_E_INSUFFICIENTBUFFER" => DIRECTMUSIC::DMUS_E_INSUFFICIENTBUFFER,
            "DMUS_E_BUFFERNOTSET" => DIRECTMUSIC::DMUS_E_BUFFERNOTSET,
            "DMUS_E_BUFFERNOTAVAILABLE" => DIRECTMUSIC::DMUS_E_BUFFERNOTAVAILABLE,
            "DMUS_E_NOTADLSCOL" => DIRECTMUSIC::DMUS_E_NOTADLSCOL,
            "DMUS_E_INVALIDOFFSET" => DIRECTMUSIC::DMUS_E_INVALIDOFFSET,
            "DMUS_E_ALREADY_LOADED" => DIRECTMUSIC::DMUS_E_ALREADY_LOADED,
            "DMUS_E_INVALIDPOS" => DIRECTMUSIC::DMUS_E_INVALIDPOS,
            "DMUS_E_INVALIDPATCH" => DIRECTMUSIC::DMUS_E_INVALIDPATCH,
            "DMUS_E_CANNOTSEEK" => DIRECTMUSIC::DMUS_E_CANNOTSEEK,
            "DMUS_E_CANNOTWRITE" => DIRECTMUSIC::DMUS_E_CANNOTWRITE,
            "DMUS_E_CHUNKNOTFOUND" => DIRECTMUSIC::DMUS_E_CHUNKNOTFOUND,
            "DMUS_E_INVALID_DOWNLOADID" => DIRECTMUSIC::DMUS_E_INVALID_DOWNLOADID,
            "DMUS_E_NOT_DOWNLOADED_TO_PORT" => DIRECTMUSIC::DMUS_E_NOT_DOWNLOADED_TO_PORT,
            "DMUS_E_ALREADY_DOWNLOADED" => DIRECTMUSIC::DMUS_E_ALREADY_DOWNLOADED,
            "DMUS_E_UNKNOWN_PROPERTY" => DIRECTMUSIC::DMUS_E_UNKNOWN_PROPERTY,
            "DMUS_E_SET_UNSUPPORTED" => DIRECTMUSIC::DMUS_E_SET_UNSUPPORTED,
            "DMUS_E_GET_UNSUPPORTED" => DIRECTMUSIC::DMUS_E_GET_UNSUPPORTED,
            "DMUS_E_NOTMONO" => DIRECTMUSIC::DMUS_E_NOTMONO,
            "DMUS_E_BADARTICULATION" => DIRECTMUSIC::DMUS_E_BADARTICULATION,
            "DMUS_E_BADINSTRUMENT" => DIRECTMUSIC::DMUS_E_BADINSTRUMENT,
            "DMUS_E_BADWAVELINK" => DIRECTMUSIC::DMUS_E_BADWAVELINK,
            "DMUS_E_NOARTICULATION" => DIRECTMUSIC::DMUS_E_NOARTICULATION,
            "DMUS_E_NOTPCM" => DIRECTMUSIC::DMUS_E_NOTPCM,
            "DMUS_E_BADWAVE" => DIRECTMUSIC::DMUS_E_BADWAVE,
            "DMUS_E_BADOFFSETTABLE" => DIRECTMUSIC::DMUS_E_BADOFFSETTABLE,
            "DMUS_E_UNKNOWNDOWNLOAD" => DIRECTMUSIC::DMUS_E_UNKNOWNDOWNLOAD,
            "DMUS_E_NOSYNTHSINK" => DIRECTMUSIC::DMUS_E_NOSYNTHSINK,
            "DMUS_E_ALREADYOPEN" => DIRECTMUSIC::DMUS_E_ALREADYOPEN,
            "DMUS_E_ALREADYCLOSED" => DIRECTMUSIC::DMUS_E_ALREADYCLOSED,
            "DMUS_E_SYNTHNOTCONFIGURED" => DIRECTMUSIC::DMUS_E_SYNTHNOTCONFIGURED,
            "DMUS_E_SYNTHACTIVE" => DIRECTMUSIC::DMUS_E_SYNTHACTIVE,
            "DMUS_E_CANNOTREAD" => DIRECTMUSIC::DMUS_E_CANNOTREAD,
            "DMUS_E_DMUSIC_RELEASED" => DIRECTMUSIC::DMUS_E_DMUSIC_RELEASED,
            "DMUS_E_BUFFER_EMPTY" => DIRECTMUSIC::DMUS_E_BUFFER_EMPTY,
            "DMUS_E_BUFFER_FULL" => DIRECTMUSIC::DMUS_E_BUFFER_FULL,
            "DMUS_E_PORT_NOT_CAPTURE" => DIRECTMUSIC::DMUS_E_PORT_NOT_CAPTURE,
            "DMUS_E_PORT_NOT_RENDER" => DIRECTMUSIC::DMUS_E_PORT_NOT_RENDER,
            "DMUS_E_DSOUND_NOT_SET" => DIRECTMUSIC::DMUS_E_DSOUND_NOT_SET,
            "DMUS_E_ALREADY_ACTIVATED" => DIRECTMUSIC::DMUS_E_ALREADY_ACTIVATED,
            "DMUS_E_INVALIDBUFFER" => DIRECTMUSIC::DMUS_E_INVALIDBUFFER,
            "DMUS_E_WAVEFORMATNOTSUPPORTED" => DIRECTMUSIC::DMUS_E_WAVEFORMATNOTSUPPORTED,
            "DMUS_E_SYNTHINACTIVE" => DIRECTMUSIC::DMUS_E_SYNTHINACTIVE,
            "DMUS_E_DSOUND_ALREADY_SET" => DIRECTMUSIC::DMUS_E_DSOUND_ALREADY_SET,
            "DMUS_E_INVALID_EVENT" => DIRECTMUSIC::DMUS_E_INVALID_EVENT,
            "DMUS_E_UNSUPPORTED_STREAM" => DIRECTMUSIC::DMUS_E_UNSUPPORTED_STREAM,
            "DMUS_E_ALREADY_INITED" => DIRECTMUSIC::DMUS_E_ALREADY_INITED,
            "DMUS_E_INVALID_BAND" => DIRECTMUSIC::DMUS_E_INVALID_BAND,
            "DMUS_E_TRACK_HDR_NOT_FIRST_CK" => DIRECTMUSIC::DMUS_E_TRACK_HDR_NOT_FIRST_CK,
            "DMUS_E_TOOL_HDR_NOT_FIRST_CK" => DIRECTMUSIC::DMUS_E_TOOL_HDR_NOT_FIRST_CK,
            "DMUS_E_INVALID_TRACK_HDR" => DIRECTMUSIC::DMUS_E_INVALID_TRACK_HDR,
            "DMUS_E_INVALID_TOOL_HDR" => DIRECTMUSIC::DMUS_E_INVALID_TOOL_HDR,
            "DMUS_E_ALL_TOOLS_FAILED" => DIRECTMUSIC::DMUS_E_ALL_TOOLS_FAILED,
            "DMUS_E_ALL_TRACKS_FAILED" => DIRECTMUSIC::DMUS_E_ALL_TRACKS_FAILED,
            "DMUS_E_NOT_FOUND" => DIRECTMUSIC::DMUS_E_NOT_FOUND,
            "DMUS_E_NOT_INIT" => DIRECTMUSIC::DMUS_E_NOT_INIT,
            "DMUS_E_TYPE_DISABLED" => DIRECTMUSIC::DMUS_E_TYPE_DISABLED,
            "DMUS_E_TYPE_UNSUPPORTED" => DIRECTMUSIC::DMUS_E_TYPE_UNSUPPORTED,
            "DMUS_E_TIME_PAST" => DIRECTMUSIC::DMUS_E_TIME_PAST,
            "DMUS_E_TRACK_NOT_FOUND" => DIRECTMUSIC::DMUS_E_TRACK_NOT_FOUND,
            "DMUS_E_TRACK_NO_CLOCKTIME_SUPPORT" => DIRECTMUSIC::DMUS_E_TRACK_NO_CLOCKTIME_SUPPORT,
            "DMUS_E_NO_MASTER_CLOCK" => DIRECTMUSIC::DMUS_E_NO_MASTER_CLOCK,
            "DMUS_E_LOADER_NOCLASSID" => DIRECTMUSIC::DMUS_E_LOADER_NOCLASSID,
            "DMUS_E_LOADER_BADPATH" => DIRECTMUSIC::DMUS_E_LOADER_BADPATH,
            "DMUS_E_LOADER_FAILEDOPEN" => DIRECTMUSIC::DMUS_E_LOADER_FAILEDOPEN,
            "DMUS_E_LOADER_FORMATNOTSUPPORTED" => DIRECTMUSIC::DMUS_E_LOADER_FORMATNOTSUPPORTED,
            "DMUS_E_LOADER_FAILEDCREATE" => DIRECTMUSIC::DMUS_E_LOADER_FAILEDCREATE,
            "DMUS_E_LOADER_OBJECTNOTFOUND" => DIRECTMUSIC::DMUS_E_LOADER_OBJECTNOTFOUND,
            "DMUS_E_LOADER_NOFILENAME" => DIRECTMUSIC::DMUS_E_LOADER_NOFILENAME,
            "DMUS_E_INVALIDFILE" => DIRECTMUSIC::DMUS_E_INVALIDFILE,
            "DMUS_E_ALREADY_EXISTS" => DIRECTMUSIC::DMUS_E_ALREADY_EXISTS,
            "DMUS_E_OUT_OF_RANGE" => DIRECTMUSIC::DMUS_E_OUT_OF_RANGE,
            "DMUS_E_SEGMENT_INIT_FAILED" => DIRECTMUSIC::DMUS_E_SEGMENT_INIT_FAILED,
            "DMUS_E_ALREADY_SENT" => DIRECTMUSIC::DMUS_E_ALREADY_SENT,
            "DMUS_E_CANNOT_FREE" => DIRECTMUSIC::DMUS_E_CANNOT_FREE,
            "DMUS_E_CANNOT_OPEN_PORT" => DIRECTMUSIC::DMUS_E_CANNOT_OPEN_PORT,
            "DMUS_E_CANNOT_CONVERT" => DIRECTMUSIC::DMUS_E_CANNOT_CONVERT,
            "DMUS_E_DESCEND_CHUNK_FAIL" => DIRECTMUSIC::DMUS_E_DESCEND_CHUNK_FAIL,
            "DMUS_E_NOT_LOADED" => DIRECTMUSIC::DMUS_E_NOT_LOADED,
            "DMUS_E_SCRIPT_LANGUAGE_INCOMPATIBLE" => DIRECTMUSIC::DMUS_E_SCRIPT_LANGUAGE_INCOMPATIBLE,
            "DMUS_E_SCRIPT_UNSUPPORTED_VARTYPE" => DIRECTMUSIC::DMUS_E_SCRIPT_UNSUPPORTED_VARTYPE,
            "DMUS_E_SCRIPT_ERROR_IN_SCRIPT" => DIRECTMUSIC::DMUS_E_SCRIPT_ERROR_IN_SCRIPT,
            "DMUS_E_SCRIPT_CANTLOAD_OLEAUT32" => DIRECTMUSIC::DMUS_E_SCRIPT_CANTLOAD_OLEAUT32,
            "DMUS_E_SCRIPT_LOADSCRIPT_ERROR" => DIRECTMUSIC::DMUS_E_SCRIPT_LOADSCRIPT_ERROR,
            "DMUS_E_SCRIPT_INVALID_FILE" => DIRECTMUSIC::DMUS_E_SCRIPT_INVALID_FILE,
            "DMUS_E_INVALID_SCRIPTTRACK" => DIRECTMUSIC::DMUS_E_INVALID_SCRIPTTRACK,
            "DMUS_E_SCRIPT_VARIABLE_NOT_FOUND" => DIRECTMUSIC::DMUS_E_SCRIPT_VARIABLE_NOT_FOUND,
            "DMUS_E_SCRIPT_ROUTINE_NOT_FOUND" => DIRECTMUSIC::DMUS_E_SCRIPT_ROUTINE_NOT_FOUND,
            "DMUS_E_SCRIPT_CONTENT_READONLY" => DIRECTMUSIC::DMUS_E_SCRIPT_CONTENT_READONLY,
            "DMUS_E_SCRIPT_NOT_A_REFERENCE" => DIRECTMUSIC::DMUS_E_SCRIPT_NOT_A_REFERENCE,
            "DMUS_E_SCRIPT_VALUE_NOT_SUPPORTED" => DIRECTMUSIC::DMUS_E_SCRIPT_VALUE_NOT_SUPPORTED,
            "DMUS_E_INVALID_SEGMENTTRIGGERTRACK" => DIRECTMUSIC::DMUS_E_INVALID_SEGMENTTRIGGERTRACK,
            "DMUS_E_INVALID_LYRICSTRACK" => DIRECTMUSIC::DMUS_E_INVALID_LYRICSTRACK,
            "DMUS_E_INVALID_PARAMCONTROLTRACK" => DIRECTMUSIC::DMUS_E_INVALID_PARAMCONTROLTRACK,
            "DMUS_E_AUDIOVBSCRIPT_SYNTAXERROR" => DIRECTMUSIC::DMUS_E_AUDIOVBSCRIPT_SYNTAXERROR,
            "DMUS_E_AUDIOVBSCRIPT_RUNTIMEERROR" => DIRECTMUSIC::DMUS_E_AUDIOVBSCRIPT_RUNTIMEERROR,
            "DMUS_E_AUDIOVBSCRIPT_OPERATIONFAILURE" => DIRECTMUSIC::DMUS_E_AUDIOVBSCRIPT_OPERATIONFAILURE,
            "DMUS_E_AUDIOPATHS_NOT_VALID" => DIRECTMUSIC::DMUS_E_AUDIOPATHS_NOT_VALID,
            "DMUS_E_AUDIOPATHS_IN_USE" => DIRECTMUSIC::DMUS_E_AUDIOPATHS_IN_USE,
            "DMUS_E_NO_AUDIOPATH_CONFIG" => DIRECTMUSIC::DMUS_E_NO_AUDIOPATH_CONFIG,
            "DMUS_E_AUDIOPATH_INACTIVE" => DIRECTMUSIC::DMUS_E_AUDIOPATH_INACTIVE,
            "DMUS_E_AUDIOPATH_NOBUFFER" => DIRECTMUSIC::DMUS_E_AUDIOPATH_NOBUFFER,
            "DMUS_E_AUDIOPATH_NOPORT" => DIRECTMUSIC::DMUS_E_AUDIOPATH_NOPORT,
            "DMUS_E_NO_AUDIOPATH" => DIRECTMUSIC::DMUS_E_NO_AUDIOPATH,
            "DMUS_E_INVALIDCHUNK" => DIRECTMUSIC::DMUS_E_INVALIDCHUNK,
            "DMUS_E_AUDIOPATH_NOGLOBALFXBUFFER" => DIRECTMUSIC::DMUS_E_AUDIOPATH_NOGLOBALFXBUFFER,
            "DMUS_E_INVALID_CONTAINER_OBJECT" => DIRECTMUSIC::DMUS_E_INVALID_CONTAINER_OBJECT,
        }
    }
    pub fn from_code(code: u32) -> DIRECTMUSIC {
        return match code {
            0x8878001E => DIRECTMUSIC::DSERR_CONTROLUNAVAIL,
            0x88780032 => DIRECTMUSIC::DSERR_INVALIDCALL,
            0x88780046 => DIRECTMUSIC::DSERR_PRIOLEVELNEEDED,
            0x88780064 => DIRECTMUSIC::DSERR_BADFORMAT,
            0x88780078 => DIRECTMUSIC::DSERR_NODRIVER,
            0x88780096 => DIRECTMUSIC::DSERR_BUFFERLOST,
            0x887800A0 => DIRECTMUSIC::DSERR_OTHERAPPHASPRIO,
            0x887800AA => DIRECTMUSIC::DSERR_UNINITIALIZED,
            0x887800BE => DIRECTMUSIC::DSERR_DS8_REQUIRED,
            0x88781101 => DIRECTMUSIC::DMUS_E_DRIVER_FAILED,
            0x88781102 => DIRECTMUSIC::DMUS_E_PORTS_OPEN,
            0x88781103 => DIRECTMUSIC::DMUS_E_DEVICE_IN_USE,
            0x88781104 => DIRECTMUSIC::DMUS_E_INSUFFICIENTBUFFER,
            0x88781105 => DIRECTMUSIC::DMUS_E_BUFFERNOTSET,
            0x88781106 => DIRECTMUSIC::DMUS_E_BUFFERNOTAVAILABLE,
            0x88781108 => DIRECTMUSIC::DMUS_E_NOTADLSCOL,
            0x88781109 => DIRECTMUSIC::DMUS_E_INVALIDOFFSET,
            0x88781111 => DIRECTMUSIC::DMUS_E_ALREADY_LOADED,
            0x88781113 => DIRECTMUSIC::DMUS_E_INVALIDPOS,
            0x88781114 => DIRECTMUSIC::DMUS_E_INVALIDPATCH,
            0x88781115 => DIRECTMUSIC::DMUS_E_CANNOTSEEK,
            0x88781116 => DIRECTMUSIC::DMUS_E_CANNOTWRITE,
            0x88781117 => DIRECTMUSIC::DMUS_E_CHUNKNOTFOUND,
            0x88781119 => DIRECTMUSIC::DMUS_E_INVALID_DOWNLOADID,
            0x88781120 => DIRECTMUSIC::DMUS_E_NOT_DOWNLOADED_TO_PORT,
            0x88781121 => DIRECTMUSIC::DMUS_E_ALREADY_DOWNLOADED,
            0x88781122 => DIRECTMUSIC::DMUS_E_UNKNOWN_PROPERTY,
            0x88781123 => DIRECTMUSIC::DMUS_E_SET_UNSUPPORTED,
            0x88781124 => DIRECTMUSIC::DMUS_E_GET_UNSUPPORTED,
            0x88781125 => DIRECTMUSIC::DMUS_E_NOTMONO,
            0x88781126 => DIRECTMUSIC::DMUS_E_BADARTICULATION,
            0x88781127 => DIRECTMUSIC::DMUS_E_BADINSTRUMENT,
            0x88781128 => DIRECTMUSIC::DMUS_E_BADWAVELINK,
            0x88781129 => DIRECTMUSIC::DMUS_E_NOARTICULATION,
            0x8878112A => DIRECTMUSIC::DMUS_E_NOTPCM,
            0x8878112B => DIRECTMUSIC::DMUS_E_BADWAVE,
            0x8878112C => DIRECTMUSIC::DMUS_E_BADOFFSETTABLE,
            0x8878112D => DIRECTMUSIC::DMUS_E_UNKNOWNDOWNLOAD,
            0x8878112E => DIRECTMUSIC::DMUS_E_NOSYNTHSINK,
            0x8878112F => DIRECTMUSIC::DMUS_E_ALREADYOPEN,
            0x88781130 => DIRECTMUSIC::DMUS_E_ALREADYCLOSED,
            0x88781131 => DIRECTMUSIC::DMUS_E_SYNTHNOTCONFIGURED,
            0x88781132 => DIRECTMUSIC::DMUS_E_SYNTHACTIVE,
            0x88781133 => DIRECTMUSIC::DMUS_E_CANNOTREAD,
            0x88781134 => DIRECTMUSIC::DMUS_E_DMUSIC_RELEASED,
            0x88781135 => DIRECTMUSIC::DMUS_E_BUFFER_EMPTY,
            0x88781136 => DIRECTMUSIC::DMUS_E_BUFFER_FULL,
            0x88781137 => DIRECTMUSIC::DMUS_E_PORT_NOT_CAPTURE,
            0x88781138 => DIRECTMUSIC::DMUS_E_PORT_NOT_RENDER,
            0x88781139 => DIRECTMUSIC::DMUS_E_DSOUND_NOT_SET,
            0x8878113A => DIRECTMUSIC::DMUS_E_ALREADY_ACTIVATED,
            0x8878113B => DIRECTMUSIC::DMUS_E_INVALIDBUFFER,
            0x8878113C => DIRECTMUSIC::DMUS_E_WAVEFORMATNOTSUPPORTED,
            0x8878113D => DIRECTMUSIC::DMUS_E_SYNTHINACTIVE,
            0x8878113E => DIRECTMUSIC::DMUS_E_DSOUND_ALREADY_SET,
            0x8878113F => DIRECTMUSIC::DMUS_E_INVALID_EVENT,
            0x88781150 => DIRECTMUSIC::DMUS_E_UNSUPPORTED_STREAM,
            0x88781151 => DIRECTMUSIC::DMUS_E_ALREADY_INITED,
            0x88781152 => DIRECTMUSIC::DMUS_E_INVALID_BAND,
            0x88781155 => DIRECTMUSIC::DMUS_E_TRACK_HDR_NOT_FIRST_CK,
            0x88781156 => DIRECTMUSIC::DMUS_E_TOOL_HDR_NOT_FIRST_CK,
            0x88781157 => DIRECTMUSIC::DMUS_E_INVALID_TRACK_HDR,
            0x88781158 => DIRECTMUSIC::DMUS_E_INVALID_TOOL_HDR,
            0x88781159 => DIRECTMUSIC::DMUS_E_ALL_TOOLS_FAILED,
            0x88781160 => DIRECTMUSIC::DMUS_E_ALL_TRACKS_FAILED,
            0x88781161 => DIRECTMUSIC::DMUS_E_NOT_FOUND,
            0x88781162 => DIRECTMUSIC::DMUS_E_NOT_INIT,
            0x88781163 => DIRECTMUSIC::DMUS_E_TYPE_DISABLED,
            0x88781164 => DIRECTMUSIC::DMUS_E_TYPE_UNSUPPORTED,
            0x88781165 => DIRECTMUSIC::DMUS_E_TIME_PAST,
            0x88781166 => DIRECTMUSIC::DMUS_E_TRACK_NOT_FOUND,
            0x88781167 => DIRECTMUSIC::DMUS_E_TRACK_NO_CLOCKTIME_SUPPORT,
            0x88781170 => DIRECTMUSIC::DMUS_E_NO_MASTER_CLOCK,
            0x88781180 => DIRECTMUSIC::DMUS_E_LOADER_NOCLASSID,
            0x88781181 => DIRECTMUSIC::DMUS_E_LOADER_BADPATH,
            0x88781182 => DIRECTMUSIC::DMUS_E_LOADER_FAILEDOPEN,
            0x88781183 => DIRECTMUSIC::DMUS_E_LOADER_FORMATNOTSUPPORTED,
            0x88781184 => DIRECTMUSIC::DMUS_E_LOADER_FAILEDCREATE,
            0x88781185 => DIRECTMUSIC::DMUS_E_LOADER_OBJECTNOTFOUND,
            0x88781186 => DIRECTMUSIC::DMUS_E_LOADER_NOFILENAME,
            0x88781200 => DIRECTMUSIC::DMUS_E_INVALIDFILE,
            0x88781201 => DIRECTMUSIC::DMUS_E_ALREADY_EXISTS,
            0x88781202 => DIRECTMUSIC::DMUS_E_OUT_OF_RANGE,
            0x88781203 => DIRECTMUSIC::DMUS_E_SEGMENT_INIT_FAILED,
            0x88781204 => DIRECTMUSIC::DMUS_E_ALREADY_SENT,
            0x88781205 => DIRECTMUSIC::DMUS_E_CANNOT_FREE,
            0x88781206 => DIRECTMUSIC::DMUS_E_CANNOT_OPEN_PORT,
            0x88781207 => DIRECTMUSIC::DMUS_E_CANNOT_CONVERT,
            0x88781210 => DIRECTMUSIC::DMUS_E_DESCEND_CHUNK_FAIL,
            0x88781211 => DIRECTMUSIC::DMUS_E_NOT_LOADED,
            0x88781213 => DIRECTMUSIC::DMUS_E_SCRIPT_LANGUAGE_INCOMPATIBLE,
            0x88781214 => DIRECTMUSIC::DMUS_E_SCRIPT_UNSUPPORTED_VARTYPE,
            0x88781215 => DIRECTMUSIC::DMUS_E_SCRIPT_ERROR_IN_SCRIPT,
            0x88781216 => DIRECTMUSIC::DMUS_E_SCRIPT_CANTLOAD_OLEAUT32,
            0x88781217 => DIRECTMUSIC::DMUS_E_SCRIPT_LOADSCRIPT_ERROR,
            0x88781218 => DIRECTMUSIC::DMUS_E_SCRIPT_INVALID_FILE,
            0x88781219 => DIRECTMUSIC::DMUS_E_INVALID_SCRIPTTRACK,
            0x8878121A => DIRECTMUSIC::DMUS_E_SCRIPT_VARIABLE_NOT_FOUND,
            0x8878121B => DIRECTMUSIC::DMUS_E_SCRIPT_ROUTINE_NOT_FOUND,
            0x8878121C => DIRECTMUSIC::DMUS_E_SCRIPT_CONTENT_READONLY,
            0x8878121D => DIRECTMUSIC::DMUS_E_SCRIPT_NOT_A_REFERENCE,
            0x8878121E => DIRECTMUSIC::DMUS_E_SCRIPT_VALUE_NOT_SUPPORTED,
            0x88781220 => DIRECTMUSIC::DMUS_E_INVALID_SEGMENTTRIGGERTRACK,
            0x88781221 => DIRECTMUSIC::DMUS_E_INVALID_LYRICSTRACK,
            0x88781222 => DIRECTMUSIC::DMUS_E_INVALID_PARAMCONTROLTRACK,
            0x88781223 => DIRECTMUSIC::DMUS_E_AUDIOVBSCRIPT_SYNTAXERROR,
            0x88781224 => DIRECTMUSIC::DMUS_E_AUDIOVBSCRIPT_RUNTIMEERROR,
            0x88781225 => DIRECTMUSIC::DMUS_E_AUDIOVBSCRIPT_OPERATIONFAILURE,
            0x88781226 => DIRECTMUSIC::DMUS_E_AUDIOPATHS_NOT_VALID,
            0x88781227 => DIRECTMUSIC::DMUS_E_AUDIOPATHS_IN_USE,
            0x88781228 => DIRECTMUSIC::DMUS_E_NO_AUDIOPATH_CONFIG,
            0x88781229 => DIRECTMUSIC::DMUS_E_AUDIOPATH_INACTIVE,
            0x8878122A => DIRECTMUSIC::DMUS_E_AUDIOPATH_NOBUFFER,
            0x8878122B => DIRECTMUSIC::DMUS_E_AUDIOPATH_NOPORT,
            0x8878122C => DIRECTMUSIC::DMUS_E_NO_AUDIOPATH,
            0x8878122D => DIRECTMUSIC::DMUS_E_INVALIDCHUNK,
            0x8878122E => DIRECTMUSIC::DMUS_E_AUDIOPATH_NOGLOBALFXBUFFER,
            0x8878122F => DIRECTMUSIC::DMUS_E_INVALID_CONTAINER_OBJECT,
        }
    }
}
