/*
 * Copyright 2023 Stanislav Mikhailov (xavetar)
 *
 * Licensed under the Creative Commons Zero v1.0 Universal (CC0) License.
 * You may obtain a copy of the License at
 *
 *     http://creativecommons.org/publicdomain/zero/1.0/
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the CC0 license is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

// It is strictly forbidden to use the from_code method, respected Microsoft decided to define
// duplicate codes, but by defining different constant names, therefore, when using these codes,
// it is mandatory to use through from_name, and not from_code. Otherwise, it may cause undefined
// behavior or an unknown exception. Because one code corresponds to several constants.

use super::{RawError};

#[derive(Clone, Debug, Copy, Eq, Hash, Ord, PartialEq, PartialOrd)]
pub enum INTERNET {
    INET_E_INVALID_URL,
    INET_E_NO_SESSION,
    INET_E_CANNOT_CONNECT,
    INET_E_RESOURCE_NOT_FOUND,
    INET_E_OBJECT_NOT_FOUND,
    INET_E_DATA_NOT_AVAILABLE,
    INET_E_DOWNLOAD_FAILURE,
    INET_E_AUTHENTICATION_REQUIRED,
    INET_E_NO_VALID_MEDIA,
    INET_E_CONNECTION_TIMEOUT,
    INET_E_INVALID_REQUEST,
    INET_E_UNKNOWN_PROTOCOL,
    INET_E_SECURITY_PROBLEM,
    INET_E_CANNOT_LOAD_DATA,
    INET_E_CANNOT_INSTANTIATE_OBJECT,
    INET_E_REDIRECT_FAILED,
    INET_E_REDIRECT_TO_DIR,
    INET_E_INVALID_CERTIFICATE,
    XML_E_INVALID_DECIMAL,
    XML_E_INVALID_HEXIDECIMAL,
    XML_E_INVALID_UNICODE,
    XML_E_INVALIDENCODING,
    XML_E_FORMATINDEX_BADINDEX,
    XML_E_FORMATINDEX_BADFORMAT,
    XML_E_EXPECTED_TOKEN,
    XML_E_UNEXPECTED_TOKEN,
    XML_E_MISSINGEQUALS,
    XML_E_MISSINGQUOTE,
    XML_E_COMMENTSYNTAX,
    XML_E_BADSTARTNAMECHAR,
    XML_E_BADNAMECHAR,
    XML_E_BADCHARINSTRING,
    XML_E_XMLDECLSYNTAX,
    XML_E_BADCHARDATA,
    XML_E_MISSINGWHITESPACE,
    XML_E_EXPECTINGTAGEND,
    XML_E_BADCHARINDTD,
    XML_E_BADCHARINDECL,
    XML_E_MISSINGSEMICOLON,
    XML_E_BADCHARINENTREF,
    XML_E_UNBALANCEDPAREN,
    XML_E_EXPECTINGOPENBRACKET,
    XML_E_BADENDCONDSECT,
    XML_E_INTERNALERROR,
    XML_E_UNEXPECTED_WHITESPACE,
    XML_E_INCOMPLETE_ENCODING,
    XML_E_BADCHARINMIXEDMODEL,
    XML_E_MISSING_STAR,
    XML_E_BADCHARINMODEL,
    XML_E_MISSING_PAREN,
    XML_E_BADCHARINENUMERATION,
    XML_E_PIDECLSYNTAX,
    XML_E_EXPECTINGCLOSEQUOTE,
    XML_E_MULTIPLE_COLONS,
    XML_E_WHITESPACEORQUESTIONMARK,
    XML_E_SUSPENDED,
    XML_E_STOPPED,
    XML_E_UNEXPECTEDENDTAG,
    XML_E_UNCLOSEDTAG,
    XML_E_DUPLICATEATTRIBUTE,
    XML_E_MULTIPLEROOTS,
    XML_E_INVALIDATROOTLEVEL,
    XML_E_BADXMLDECL,
    XML_E_MISSINGROOT,
    XML_E_UNEXPECTEDEOF,
    XML_E_BADPEREFINSUBSET,
    XML_E_PE_NESTING,
    XML_E_INVALID_CDATACLOSINGTAG,
    XML_E_UNCLOSEDPI,
    XML_E_UNCLOSEDSTARTTAG,
    XML_E_UNCLOSEDENDTAG,
    XML_E_UNCLOSEDSTRING,
    XML_E_UNCLOSEDCOMMENT,
    XML_E_UNCLOSEDDECL,
    XML_E_UNCLOSEDMARKUPDECL,
    XML_E_UNCLOSEDCDATA,
    XML_E_BADDECLNAME,
    XML_E_BADEXTERNALID,
    XML_E_BADELEMENTINDTD,
    XML_E_RESERVEDNAMESPACE,
    XML_E_EXPECTING_VERSION,
    XML_E_EXPECTING_ENCODING,
    XML_E_EXPECTING_NAME,
    XML_E_UNEXPECTED_ATTRIBUTE,
    XML_E_ENDTAGMISMATCH,
    XML_E_INVALIDSWITCH,
    XML_E_EXPECTING_NDATA,
    XML_E_INVALID_MODEL,
    XML_E_INVALID_TYPE,
    XML_E_INVALIDXMLSPACE,
    XML_E_MULTI_ATTR_VALUE,
    XML_E_INVALID_PRESENCE,
    XML_E_BADXMLCASE,
    XML_E_CONDSECTINSUBSET,
    XML_E_CDATAINVALID,
    XML_E_INVALID_STANDALONE,
    XML_E_UNEXPECTED_STANDALONE,
    XML_E_DOCTYPE_IN_DTD,
    XML_E_MISSING_ENTITY,
    XML_E_ENTITYREF_INNAME,
    XML_E_DOCTYPE_OUTSIDE_PROLOG,
    XML_E_INVALID_VERSION,
    XML_E_DTDELEMENT_OUTSIDE_DTD,
    XML_E_DUPLICATEDOCTYPE,
    XML_E_RESOURCE,
    MX_E_MX,
    MX_E_INPUTEND,
    MX_E_ENCODING,
    MX_E_ENCODINGSWITCH,
    MX_E_ENCODINGSIGNATURE,
    WC_E_WC,
    WC_E_WHITESPACE,
    WC_E_SEMICOLON,
    WC_E_GREATERTHAN,
    WC_E_QUOTE,
    WC_E_EQUAL,
    WC_E_LESSTHAN,
    WC_E_HEXDIGIT,
    WC_E_DIGIT,
    WC_E_LEFTBRACKET,
    WC_E_LEFTPAREN,
    WC_E_XMLCHARACTER,
    WC_E_NAMECHARACTER,
    WC_E_SYNTAX,
    WC_E_CDSECT,
    WC_E_COMMENT,
    WC_E_CONDSECT,
    WC_E_DECLATTLIST,
    WC_E_DECLDOCTYPE,
    WC_E_DECLELEMENT,
    WC_E_DECLENTITY,
    WC_E_DECLNOTATION,
    WC_E_NDATA,
    WC_E_PUBLIC,
    WC_E_SYSTEM,
    WC_E_NAME,
    WC_E_ROOTELEMENT,
    WC_E_ELEMENTMATCH,
    WC_E_UNIQUEATTRIBUTE,
    WC_E_TEXTXMLDECL,
    WC_E_LEADINGXML,
    WC_E_TEXTDECL,
    WC_E_XMLDECL,
    WC_E_ENCNAME,
    WC_E_PUBLICID,
    WC_E_PESINTERNALSUBSET,
    WC_E_PESBETWEENDECLS,
    WC_E_NORECURSION,
    WC_E_ENTITYCONTENT,
    WC_E_UNDECLAREDENTITY,
    WC_E_PARSEDENTITY,
    WC_E_NOEXTERNALENTITYREF,
    WC_E_PI,
    WC_E_SYSTEMID,
    WC_E_QUESTIONMARK,
    WC_E_CDSECTEND,
    WC_E_MOREDATA,
    WC_E_DTDPROHIBITED,
    WC_E_INVALIDXMLSPACE,
    NC_E_NC,
    NC_E_QNAMECHARACTER,
    NC_E_QNAMECOLON,
    NC_E_NAMECOLON,
    NC_E_DECLAREDPREFIX,
    NC_E_UNDECLAREDPREFIX,
    NC_E_EMPTYURI,
    NC_E_XMLPREFIXRESERVED,
    NC_E_XMLNSPREFIXRESERVED,
    NC_E_XMLURIRESERVED,
    NC_E_XMLNSURIRESERVED,
    SC_E_SC,
    SC_E_MAXELEMENTDEPTH,
    SC_E_MAXENTITYEXPANSION,
    WR_E_WR,
    WR_E_NONWHITESPACE,
    WR_E_NSPREFIXDECLARED,
    WR_E_NSPREFIXWITHEMPTYNSURI,
    WR_E_DUPLICATEATTRIBUTE,
    WR_E_XMLNSPREFIXDECLARATION,
    WR_E_XMLPREFIXDECLARATION,
    WR_E_XMLURIDECLARATION,
    WR_E_XMLNSURIDECLARATION,
    WR_E_NAMESPACEUNDECLARED,
    WR_E_INVALIDXMLSPACE,
    WR_E_INVALIDACTION,
    WR_E_INVALIDSURROGATEPAIR,
}

impl INTERNET {
    pub fn code(&self) -> u32 {
        return match self {
            INTERNET::INET_E_INVALID_URL => 0x800C0002 as u32,
            INTERNET::INET_E_NO_SESSION => 0x800C0003 as u32,
            INTERNET::INET_E_CANNOT_CONNECT => 0x800C0004 as u32,
            INTERNET::INET_E_RESOURCE_NOT_FOUND => 0x800C0005 as u32,
            INTERNET::INET_E_OBJECT_NOT_FOUND => 0x800C0006 as u32,
            INTERNET::INET_E_DATA_NOT_AVAILABLE => 0x800C0007 as u32,
            INTERNET::INET_E_DOWNLOAD_FAILURE => 0x800C0008 as u32,
            INTERNET::INET_E_AUTHENTICATION_REQUIRED => 0x800C0009 as u32,
            INTERNET::INET_E_NO_VALID_MEDIA => 0x800C000A as u32,
            INTERNET::INET_E_CONNECTION_TIMEOUT => 0x800C000B as u32,
            INTERNET::INET_E_INVALID_REQUEST => 0x800C000C as u32,
            INTERNET::INET_E_UNKNOWN_PROTOCOL => 0x800C000D as u32,
            INTERNET::INET_E_SECURITY_PROBLEM => 0x800C000E as u32,
            INTERNET::INET_E_CANNOT_LOAD_DATA => 0x800C000F as u32,
            INTERNET::INET_E_CANNOT_INSTANTIATE_OBJECT => 0x800C0010 as u32,
            INTERNET::INET_E_REDIRECT_FAILED => 0x800C0014 as u32,
            INTERNET::INET_E_REDIRECT_TO_DIR => 0x800C0015 as u32,
            INTERNET::INET_E_INVALID_CERTIFICATE => 0x800C0019 as u32,
            INTERNET::XML_E_INVALID_DECIMAL => 0xC00CE01D as u32,
            INTERNET::XML_E_INVALID_HEXIDECIMAL => 0xC00CE01E as u32,
            INTERNET::XML_E_INVALID_UNICODE => 0xC00CE01F as u32,
            INTERNET::XML_E_INVALIDENCODING => 0xC00CE06E as u32,
            INTERNET::XML_E_FORMATINDEX_BADINDEX => 0xC00CE306 as u32,
            INTERNET::XML_E_FORMATINDEX_BADFORMAT => 0xC00CE307 as u32,
            INTERNET::XML_E_EXPECTED_TOKEN => 0xC00CE380 as u32,
            INTERNET::XML_E_UNEXPECTED_TOKEN => 0xC00CE381 as u32,
            INTERNET::XML_E_MISSINGEQUALS => 0xC00CE501 as u32,
            INTERNET::XML_E_MISSINGQUOTE => 0xC00CE502 as u32,
            INTERNET::XML_E_COMMENTSYNTAX => 0xC00CE503 as u32,
            INTERNET::XML_E_BADSTARTNAMECHAR => 0xC00CE504 as u32,
            INTERNET::XML_E_BADNAMECHAR => 0xC00CE505 as u32,
            INTERNET::XML_E_BADCHARINSTRING => 0xC00CE506 as u32,
            INTERNET::XML_E_XMLDECLSYNTAX => 0xC00CE507 as u32,
            INTERNET::XML_E_BADCHARDATA => 0xC00CE508 as u32,
            INTERNET::XML_E_MISSINGWHITESPACE => 0xC00CE509 as u32,
            INTERNET::XML_E_EXPECTINGTAGEND => 0xC00CE50A as u32,
            INTERNET::XML_E_BADCHARINDTD => 0xC00CE50B as u32,
            INTERNET::XML_E_BADCHARINDECL => 0xC00CE50C as u32,
            INTERNET::XML_E_MISSINGSEMICOLON => 0xC00CE50D as u32,
            INTERNET::XML_E_BADCHARINENTREF => 0xC00CE50E as u32,
            INTERNET::XML_E_UNBALANCEDPAREN => 0xC00CE50F as u32,
            INTERNET::XML_E_EXPECTINGOPENBRACKET => 0xC00CE510 as u32,
            INTERNET::XML_E_BADENDCONDSECT => 0xC00CE511 as u32,
            INTERNET::XML_E_INTERNALERROR => 0xC00CE512 as u32,
            INTERNET::XML_E_UNEXPECTED_WHITESPACE => 0xC00CE513 as u32,
            INTERNET::XML_E_INCOMPLETE_ENCODING => 0xC00CE514 as u32,
            INTERNET::XML_E_BADCHARINMIXEDMODEL => 0xC00CE515 as u32,
            INTERNET::XML_E_MISSING_STAR => 0xC00CE516 as u32,
            INTERNET::XML_E_BADCHARINMODEL => 0xC00CE517 as u32,
            INTERNET::XML_E_MISSING_PAREN => 0xC00CE518 as u32,
            INTERNET::XML_E_BADCHARINENUMERATION => 0xC00CE519 as u32,
            INTERNET::XML_E_PIDECLSYNTAX => 0xC00CE51A as u32,
            INTERNET::XML_E_EXPECTINGCLOSEQUOTE => 0xC00CE51B as u32,
            INTERNET::XML_E_MULTIPLE_COLONS => 0xC00CE51C as u32,
            INTERNET::XML_E_WHITESPACEORQUESTIONMARK => 0xC00CE520 as u32,
            INTERNET::XML_E_SUSPENDED => 0xC00CE550 as u32,
            INTERNET::XML_E_STOPPED => 0xC00CE551 as u32,
            INTERNET::XML_E_UNEXPECTEDENDTAG => 0xC00CE552 as u32,
            INTERNET::XML_E_UNCLOSEDTAG => 0xC00CE553 as u32,
            INTERNET::XML_E_DUPLICATEATTRIBUTE => 0xC00CE554 as u32,
            INTERNET::XML_E_MULTIPLEROOTS => 0xC00CE555 as u32,
            INTERNET::XML_E_INVALIDATROOTLEVEL => 0xC00CE556 as u32,
            INTERNET::XML_E_BADXMLDECL => 0xC00CE557 as u32,
            INTERNET::XML_E_MISSINGROOT => 0xC00CE558 as u32,
            INTERNET::XML_E_UNEXPECTEDEOF => 0xC00CE559 as u32,
            INTERNET::XML_E_BADPEREFINSUBSET => 0xC00CE55A as u32,
            INTERNET::XML_E_PE_NESTING => 0xC00CE55B as u32,
            INTERNET::XML_E_INVALID_CDATACLOSINGTAG => 0xC00CE55C as u32,
            INTERNET::XML_E_UNCLOSEDPI => 0xC00CE55D as u32,
            INTERNET::XML_E_UNCLOSEDSTARTTAG => 0xC00CE55E as u32,
            INTERNET::XML_E_UNCLOSEDENDTAG => 0xC00CE55F as u32,
            INTERNET::XML_E_UNCLOSEDSTRING => 0xC00CE560 as u32,
            INTERNET::XML_E_UNCLOSEDCOMMENT => 0xC00CE561 as u32,
            INTERNET::XML_E_UNCLOSEDDECL => 0xC00CE562 as u32,
            INTERNET::XML_E_UNCLOSEDMARKUPDECL => 0xC00CE563 as u32,
            INTERNET::XML_E_UNCLOSEDCDATA => 0xC00CE564 as u32,
            INTERNET::XML_E_BADDECLNAME => 0xC00CE565 as u32,
            INTERNET::XML_E_BADEXTERNALID => 0xC00CE566 as u32,
            INTERNET::XML_E_BADELEMENTINDTD => 0xC00CE567 as u32,
            INTERNET::XML_E_RESERVEDNAMESPACE => 0xC00CE568 as u32,
            INTERNET::XML_E_EXPECTING_VERSION => 0xC00CE569 as u32,
            INTERNET::XML_E_EXPECTING_ENCODING => 0xC00CE56A as u32,
            INTERNET::XML_E_EXPECTING_NAME => 0xC00CE56B as u32,
            INTERNET::XML_E_UNEXPECTED_ATTRIBUTE => 0xC00CE56C as u32,
            INTERNET::XML_E_ENDTAGMISMATCH => 0xC00CE56D as u32,
            INTERNET::XML_E_INVALIDSWITCH => 0xC00CE56F as u32,
            INTERNET::XML_E_EXPECTING_NDATA => 0xC00CE570 as u32,
            INTERNET::XML_E_INVALID_MODEL => 0xC00CE571 as u32,
            INTERNET::XML_E_INVALID_TYPE => 0xC00CE572 as u32,
            INTERNET::XML_E_INVALIDXMLSPACE => 0xC00CE573 as u32,
            INTERNET::XML_E_MULTI_ATTR_VALUE => 0xC00CE574 as u32,
            INTERNET::XML_E_INVALID_PRESENCE => 0xC00CE575 as u32,
            INTERNET::XML_E_BADXMLCASE => 0xC00CE576 as u32,
            INTERNET::XML_E_CONDSECTINSUBSET => 0xC00CE577 as u32,
            INTERNET::XML_E_CDATAINVALID => 0xC00CE578 as u32,
            INTERNET::XML_E_INVALID_STANDALONE => 0xC00CE579 as u32,
            INTERNET::XML_E_UNEXPECTED_STANDALONE => 0xC00CE57A as u32,
            INTERNET::XML_E_DOCTYPE_IN_DTD => 0xC00CE57B as u32,
            INTERNET::XML_E_MISSING_ENTITY => 0xC00CE57C as u32,
            INTERNET::XML_E_ENTITYREF_INNAME => 0xC00CE57D as u32,
            INTERNET::XML_E_DOCTYPE_OUTSIDE_PROLOG => 0xC00CE57E as u32,
            INTERNET::XML_E_INVALID_VERSION => 0xC00CE57F as u32,
            INTERNET::XML_E_DTDELEMENT_OUTSIDE_DTD => 0xC00CE580 as u32,
            INTERNET::XML_E_DUPLICATEDOCTYPE => 0xC00CE581 as u32,
            INTERNET::XML_E_RESOURCE => 0xC00CE582 as u32,
            INTERNET::MX_E_MX => 0xC00CEE00 as u32,
            INTERNET::MX_E_INPUTEND => 0xC00CEE01 as u32,
            INTERNET::MX_E_ENCODING => 0xC00CEE02 as u32,
            INTERNET::MX_E_ENCODINGSWITCH => 0xC00CEE03 as u32,
            INTERNET::MX_E_ENCODINGSIGNATURE => 0xC00CEE04 as u32,
            INTERNET::WC_E_WC => 0xC00CEE20 as u32,
            INTERNET::WC_E_WHITESPACE => 0xC00CEE21 as u32,
            INTERNET::WC_E_SEMICOLON => 0xC00CEE22 as u32,
            INTERNET::WC_E_GREATERTHAN => 0xC00CEE23 as u32,
            INTERNET::WC_E_QUOTE => 0xC00CEE24 as u32,
            INTERNET::WC_E_EQUAL => 0xC00CEE25 as u32,
            INTERNET::WC_E_LESSTHAN => 0xC00CEE26 as u32,
            INTERNET::WC_E_HEXDIGIT => 0xC00CEE27 as u32,
            INTERNET::WC_E_DIGIT => 0xC00CEE28 as u32,
            INTERNET::WC_E_LEFTBRACKET => 0xC00CEE29 as u32,
            INTERNET::WC_E_LEFTPAREN => 0xC00CEE2A as u32,
            INTERNET::WC_E_XMLCHARACTER => 0xC00CEE2B as u32,
            INTERNET::WC_E_NAMECHARACTER => 0xC00CEE2C as u32,
            INTERNET::WC_E_SYNTAX => 0xC00CEE2D as u32,
            INTERNET::WC_E_CDSECT => 0xC00CEE2E as u32,
            INTERNET::WC_E_COMMENT => 0xC00CEE2F as u32,
            INTERNET::WC_E_CONDSECT => 0xC00CEE30 as u32,
            INTERNET::WC_E_DECLATTLIST => 0xC00CEE31 as u32,
            INTERNET::WC_E_DECLDOCTYPE => 0xC00CEE32 as u32,
            INTERNET::WC_E_DECLELEMENT => 0xC00CEE33 as u32,
            INTERNET::WC_E_DECLENTITY => 0xC00CEE34 as u32,
            INTERNET::WC_E_DECLNOTATION => 0xC00CEE35 as u32,
            INTERNET::WC_E_NDATA => 0xC00CEE36 as u32,
            INTERNET::WC_E_PUBLIC => 0xC00CEE37 as u32,
            INTERNET::WC_E_SYSTEM => 0xC00CEE38 as u32,
            INTERNET::WC_E_NAME => 0xC00CEE39 as u32,
            INTERNET::WC_E_ROOTELEMENT => 0xC00CEE3A as u32,
            INTERNET::WC_E_ELEMENTMATCH => 0xC00CEE3B as u32,
            INTERNET::WC_E_UNIQUEATTRIBUTE => 0xC00CEE3C as u32,
            INTERNET::WC_E_TEXTXMLDECL => 0xC00CEE3D as u32,
            INTERNET::WC_E_LEADINGXML => 0xC00CEE3E as u32,
            INTERNET::WC_E_TEXTDECL => 0xC00CEE3F as u32,
            INTERNET::WC_E_XMLDECL => 0xC00CEE40 as u32,
            INTERNET::WC_E_ENCNAME => 0xC00CEE41 as u32,
            INTERNET::WC_E_PUBLICID => 0xC00CEE42 as u32,
            INTERNET::WC_E_PESINTERNALSUBSET => 0xC00CEE43 as u32,
            INTERNET::WC_E_PESBETWEENDECLS => 0xC00CEE44 as u32,
            INTERNET::WC_E_NORECURSION => 0xC00CEE45 as u32,
            INTERNET::WC_E_ENTITYCONTENT => 0xC00CEE46 as u32,
            INTERNET::WC_E_UNDECLAREDENTITY => 0xC00CEE47 as u32,
            INTERNET::WC_E_PARSEDENTITY => 0xC00CEE48 as u32,
            INTERNET::WC_E_NOEXTERNALENTITYREF => 0xC00CEE49 as u32,
            INTERNET::WC_E_PI => 0xC00CEE4A as u32,
            INTERNET::WC_E_SYSTEMID => 0xC00CEE4B as u32,
            INTERNET::WC_E_QUESTIONMARK => 0xC00CEE4C as u32,
            INTERNET::WC_E_CDSECTEND => 0xC00CEE4D as u32,
            INTERNET::WC_E_MOREDATA => 0xC00CEE4E as u32,
            INTERNET::WC_E_DTDPROHIBITED => 0xC00CEE4F as u32,
            INTERNET::WC_E_INVALIDXMLSPACE => 0xC00CEE50 as u32,
            INTERNET::NC_E_NC => 0xC00CEE60 as u32,
            INTERNET::NC_E_QNAMECHARACTER => 0xC00CEE61 as u32,
            INTERNET::NC_E_QNAMECOLON => 0xC00CEE62 as u32,
            INTERNET::NC_E_NAMECOLON => 0xC00CEE63 as u32,
            INTERNET::NC_E_DECLAREDPREFIX => 0xC00CEE64 as u32,
            INTERNET::NC_E_UNDECLAREDPREFIX => 0xC00CEE65 as u32,
            INTERNET::NC_E_EMPTYURI => 0xC00CEE66 as u32,
            INTERNET::NC_E_XMLPREFIXRESERVED => 0xC00CEE67 as u32,
            INTERNET::NC_E_XMLNSPREFIXRESERVED => 0xC00CEE68 as u32,
            INTERNET::NC_E_XMLURIRESERVED => 0xC00CEE69 as u32,
            INTERNET::NC_E_XMLNSURIRESERVED => 0xC00CEE6A as u32,
            INTERNET::SC_E_SC => 0xC00CEE80 as u32,
            INTERNET::SC_E_MAXELEMENTDEPTH => 0xC00CEE81 as u32,
            INTERNET::SC_E_MAXENTITYEXPANSION => 0xC00CEE82 as u32,
            INTERNET::WR_E_WR => 0xC00CEF00 as u32,
            INTERNET::WR_E_NONWHITESPACE => 0xC00CEF01 as u32,
            INTERNET::WR_E_NSPREFIXDECLARED => 0xC00CEF02 as u32,
            INTERNET::WR_E_NSPREFIXWITHEMPTYNSURI => 0xC00CEF03 as u32,
            INTERNET::WR_E_DUPLICATEATTRIBUTE => 0xC00CEF04 as u32,
            INTERNET::WR_E_XMLNSPREFIXDECLARATION => 0xC00CEF05 as u32,
            INTERNET::WR_E_XMLPREFIXDECLARATION => 0xC00CEF06 as u32,
            INTERNET::WR_E_XMLURIDECLARATION => 0xC00CEF07 as u32,
            INTERNET::WR_E_XMLNSURIDECLARATION => 0xC00CEF08 as u32,
            INTERNET::WR_E_NAMESPACEUNDECLARED => 0xC00CEF09 as u32,
            INTERNET::WR_E_INVALIDXMLSPACE => 0xC00CEF0A as u32,
            INTERNET::WR_E_INVALIDACTION => 0xC00CEF0B as u32,
            INTERNET::WR_E_INVALIDSURROGATEPAIR => 0xC00CEF0C as u32,
        }
    }

    pub fn error(&self) -> RawError {
        return match self {
            INTERNET::INET_E_INVALID_URL => RawError::Kind(INTERNET::INET_E_INVALID_URL),
            INTERNET::INET_E_NO_SESSION => RawError::Kind(INTERNET::INET_E_NO_SESSION),
            INTERNET::INET_E_CANNOT_CONNECT => RawError::Kind(INTERNET::INET_E_CANNOT_CONNECT),
            INTERNET::INET_E_RESOURCE_NOT_FOUND => RawError::Kind(INTERNET::INET_E_RESOURCE_NOT_FOUND),
            INTERNET::INET_E_OBJECT_NOT_FOUND => RawError::Kind(INTERNET::INET_E_OBJECT_NOT_FOUND),
            INTERNET::INET_E_DATA_NOT_AVAILABLE => RawError::Kind(INTERNET::INET_E_DATA_NOT_AVAILABLE),
            INTERNET::INET_E_DOWNLOAD_FAILURE => RawError::Kind(INTERNET::INET_E_DOWNLOAD_FAILURE),
            INTERNET::INET_E_AUTHENTICATION_REQUIRED => RawError::Kind(INTERNET::INET_E_AUTHENTICATION_REQUIRED),
            INTERNET::INET_E_NO_VALID_MEDIA => RawError::Kind(INTERNET::INET_E_NO_VALID_MEDIA),
            INTERNET::INET_E_CONNECTION_TIMEOUT => RawError::Kind(INTERNET::INET_E_CONNECTION_TIMEOUT),
            INTERNET::INET_E_INVALID_REQUEST => RawError::Kind(INTERNET::INET_E_INVALID_REQUEST),
            INTERNET::INET_E_UNKNOWN_PROTOCOL => RawError::Kind(INTERNET::INET_E_UNKNOWN_PROTOCOL),
            INTERNET::INET_E_SECURITY_PROBLEM => RawError::Kind(INTERNET::INET_E_SECURITY_PROBLEM),
            INTERNET::INET_E_CANNOT_LOAD_DATA => RawError::Kind(INTERNET::INET_E_CANNOT_LOAD_DATA),
            INTERNET::INET_E_CANNOT_INSTANTIATE_OBJECT => RawError::Kind(INTERNET::INET_E_CANNOT_INSTANTIATE_OBJECT),
            INTERNET::INET_E_REDIRECT_FAILED => RawError::Kind(INTERNET::INET_E_REDIRECT_FAILED),
            INTERNET::INET_E_REDIRECT_TO_DIR => RawError::Kind(INTERNET::INET_E_REDIRECT_TO_DIR),
            INTERNET::INET_E_INVALID_CERTIFICATE => RawError::Kind(INTERNET::INET_E_INVALID_CERTIFICATE),
            INTERNET::XML_E_INVALID_DECIMAL => RawError::Kind(INTERNET::XML_E_INVALID_DECIMAL),
            INTERNET::XML_E_INVALID_HEXIDECIMAL => RawError::Kind(INTERNET::XML_E_INVALID_HEXIDECIMAL),
            INTERNET::XML_E_INVALID_UNICODE => RawError::Kind(INTERNET::XML_E_INVALID_UNICODE),
            INTERNET::XML_E_INVALIDENCODING => RawError::Kind(INTERNET::XML_E_INVALIDENCODING),
            INTERNET::XML_E_FORMATINDEX_BADINDEX => RawError::Kind(INTERNET::XML_E_FORMATINDEX_BADINDEX),
            INTERNET::XML_E_FORMATINDEX_BADFORMAT => RawError::Kind(INTERNET::XML_E_FORMATINDEX_BADFORMAT),
            INTERNET::XML_E_EXPECTED_TOKEN => RawError::Kind(INTERNET::XML_E_EXPECTED_TOKEN),
            INTERNET::XML_E_UNEXPECTED_TOKEN => RawError::Kind(INTERNET::XML_E_UNEXPECTED_TOKEN),
            INTERNET::XML_E_MISSINGEQUALS => RawError::Kind(INTERNET::XML_E_MISSINGEQUALS),
            INTERNET::XML_E_MISSINGQUOTE => RawError::Kind(INTERNET::XML_E_MISSINGQUOTE),
            INTERNET::XML_E_COMMENTSYNTAX => RawError::Kind(INTERNET::XML_E_COMMENTSYNTAX),
            INTERNET::XML_E_BADSTARTNAMECHAR => RawError::Kind(INTERNET::XML_E_BADSTARTNAMECHAR),
            INTERNET::XML_E_BADNAMECHAR => RawError::Kind(INTERNET::XML_E_BADNAMECHAR),
            INTERNET::XML_E_BADCHARINSTRING => RawError::Kind(INTERNET::XML_E_BADCHARINSTRING),
            INTERNET::XML_E_XMLDECLSYNTAX => RawError::Kind(INTERNET::XML_E_XMLDECLSYNTAX),
            INTERNET::XML_E_BADCHARDATA => RawError::Kind(INTERNET::XML_E_BADCHARDATA),
            INTERNET::XML_E_MISSINGWHITESPACE => RawError::Kind(INTERNET::XML_E_MISSINGWHITESPACE),
            INTERNET::XML_E_EXPECTINGTAGEND => RawError::Kind(INTERNET::XML_E_EXPECTINGTAGEND),
            INTERNET::XML_E_BADCHARINDTD => RawError::Kind(INTERNET::XML_E_BADCHARINDTD),
            INTERNET::XML_E_BADCHARINDECL => RawError::Kind(INTERNET::XML_E_BADCHARINDECL),
            INTERNET::XML_E_MISSINGSEMICOLON => RawError::Kind(INTERNET::XML_E_MISSINGSEMICOLON),
            INTERNET::XML_E_BADCHARINENTREF => RawError::Kind(INTERNET::XML_E_BADCHARINENTREF),
            INTERNET::XML_E_UNBALANCEDPAREN => RawError::Kind(INTERNET::XML_E_UNBALANCEDPAREN),
            INTERNET::XML_E_EXPECTINGOPENBRACKET => RawError::Kind(INTERNET::XML_E_EXPECTINGOPENBRACKET),
            INTERNET::XML_E_BADENDCONDSECT => RawError::Kind(INTERNET::XML_E_BADENDCONDSECT),
            INTERNET::XML_E_INTERNALERROR => RawError::Kind(INTERNET::XML_E_INTERNALERROR),
            INTERNET::XML_E_UNEXPECTED_WHITESPACE => RawError::Kind(INTERNET::XML_E_UNEXPECTED_WHITESPACE),
            INTERNET::XML_E_INCOMPLETE_ENCODING => RawError::Kind(INTERNET::XML_E_INCOMPLETE_ENCODING),
            INTERNET::XML_E_BADCHARINMIXEDMODEL => RawError::Kind(INTERNET::XML_E_BADCHARINMIXEDMODEL),
            INTERNET::XML_E_MISSING_STAR => RawError::Kind(INTERNET::XML_E_MISSING_STAR),
            INTERNET::XML_E_BADCHARINMODEL => RawError::Kind(INTERNET::XML_E_BADCHARINMODEL),
            INTERNET::XML_E_MISSING_PAREN => RawError::Kind(INTERNET::XML_E_MISSING_PAREN),
            INTERNET::XML_E_BADCHARINENUMERATION => RawError::Kind(INTERNET::XML_E_BADCHARINENUMERATION),
            INTERNET::XML_E_PIDECLSYNTAX => RawError::Kind(INTERNET::XML_E_PIDECLSYNTAX),
            INTERNET::XML_E_EXPECTINGCLOSEQUOTE => RawError::Kind(INTERNET::XML_E_EXPECTINGCLOSEQUOTE),
            INTERNET::XML_E_MULTIPLE_COLONS => RawError::Kind(INTERNET::XML_E_MULTIPLE_COLONS),
            INTERNET::XML_E_WHITESPACEORQUESTIONMARK => RawError::Kind(INTERNET::XML_E_WHITESPACEORQUESTIONMARK),
            INTERNET::XML_E_SUSPENDED => RawError::Kind(INTERNET::XML_E_SUSPENDED),
            INTERNET::XML_E_STOPPED => RawError::Kind(INTERNET::XML_E_STOPPED),
            INTERNET::XML_E_UNEXPECTEDENDTAG => RawError::Kind(INTERNET::XML_E_UNEXPECTEDENDTAG),
            INTERNET::XML_E_UNCLOSEDTAG => RawError::Kind(INTERNET::XML_E_UNCLOSEDTAG),
            INTERNET::XML_E_DUPLICATEATTRIBUTE => RawError::Kind(INTERNET::XML_E_DUPLICATEATTRIBUTE),
            INTERNET::XML_E_MULTIPLEROOTS => RawError::Kind(INTERNET::XML_E_MULTIPLEROOTS),
            INTERNET::XML_E_INVALIDATROOTLEVEL => RawError::Kind(INTERNET::XML_E_INVALIDATROOTLEVEL),
            INTERNET::XML_E_BADXMLDECL => RawError::Kind(INTERNET::XML_E_BADXMLDECL),
            INTERNET::XML_E_MISSINGROOT => RawError::Kind(INTERNET::XML_E_MISSINGROOT),
            INTERNET::XML_E_UNEXPECTEDEOF => RawError::Kind(INTERNET::XML_E_UNEXPECTEDEOF),
            INTERNET::XML_E_BADPEREFINSUBSET => RawError::Kind(INTERNET::XML_E_BADPEREFINSUBSET),
            INTERNET::XML_E_PE_NESTING => RawError::Kind(INTERNET::XML_E_PE_NESTING),
            INTERNET::XML_E_INVALID_CDATACLOSINGTAG => RawError::Kind(INTERNET::XML_E_INVALID_CDATACLOSINGTAG),
            INTERNET::XML_E_UNCLOSEDPI => RawError::Kind(INTERNET::XML_E_UNCLOSEDPI),
            INTERNET::XML_E_UNCLOSEDSTARTTAG => RawError::Kind(INTERNET::XML_E_UNCLOSEDSTARTTAG),
            INTERNET::XML_E_UNCLOSEDENDTAG => RawError::Kind(INTERNET::XML_E_UNCLOSEDENDTAG),
            INTERNET::XML_E_UNCLOSEDSTRING => RawError::Kind(INTERNET::XML_E_UNCLOSEDSTRING),
            INTERNET::XML_E_UNCLOSEDCOMMENT => RawError::Kind(INTERNET::XML_E_UNCLOSEDCOMMENT),
            INTERNET::XML_E_UNCLOSEDDECL => RawError::Kind(INTERNET::XML_E_UNCLOSEDDECL),
            INTERNET::XML_E_UNCLOSEDMARKUPDECL => RawError::Kind(INTERNET::XML_E_UNCLOSEDMARKUPDECL),
            INTERNET::XML_E_UNCLOSEDCDATA => RawError::Kind(INTERNET::XML_E_UNCLOSEDCDATA),
            INTERNET::XML_E_BADDECLNAME => RawError::Kind(INTERNET::XML_E_BADDECLNAME),
            INTERNET::XML_E_BADEXTERNALID => RawError::Kind(INTERNET::XML_E_BADEXTERNALID),
            INTERNET::XML_E_BADELEMENTINDTD => RawError::Kind(INTERNET::XML_E_BADELEMENTINDTD),
            INTERNET::XML_E_RESERVEDNAMESPACE => RawError::Kind(INTERNET::XML_E_RESERVEDNAMESPACE),
            INTERNET::XML_E_EXPECTING_VERSION => RawError::Kind(INTERNET::XML_E_EXPECTING_VERSION),
            INTERNET::XML_E_EXPECTING_ENCODING => RawError::Kind(INTERNET::XML_E_EXPECTING_ENCODING),
            INTERNET::XML_E_EXPECTING_NAME => RawError::Kind(INTERNET::XML_E_EXPECTING_NAME),
            INTERNET::XML_E_UNEXPECTED_ATTRIBUTE => RawError::Kind(INTERNET::XML_E_UNEXPECTED_ATTRIBUTE),
            INTERNET::XML_E_ENDTAGMISMATCH => RawError::Kind(INTERNET::XML_E_ENDTAGMISMATCH),
            INTERNET::XML_E_INVALIDSWITCH => RawError::Kind(INTERNET::XML_E_INVALIDSWITCH),
            INTERNET::XML_E_EXPECTING_NDATA => RawError::Kind(INTERNET::XML_E_EXPECTING_NDATA),
            INTERNET::XML_E_INVALID_MODEL => RawError::Kind(INTERNET::XML_E_INVALID_MODEL),
            INTERNET::XML_E_INVALID_TYPE => RawError::Kind(INTERNET::XML_E_INVALID_TYPE),
            INTERNET::XML_E_INVALIDXMLSPACE => RawError::Kind(INTERNET::XML_E_INVALIDXMLSPACE),
            INTERNET::XML_E_MULTI_ATTR_VALUE => RawError::Kind(INTERNET::XML_E_MULTI_ATTR_VALUE),
            INTERNET::XML_E_INVALID_PRESENCE => RawError::Kind(INTERNET::XML_E_INVALID_PRESENCE),
            INTERNET::XML_E_BADXMLCASE => RawError::Kind(INTERNET::XML_E_BADXMLCASE),
            INTERNET::XML_E_CONDSECTINSUBSET => RawError::Kind(INTERNET::XML_E_CONDSECTINSUBSET),
            INTERNET::XML_E_CDATAINVALID => RawError::Kind(INTERNET::XML_E_CDATAINVALID),
            INTERNET::XML_E_INVALID_STANDALONE => RawError::Kind(INTERNET::XML_E_INVALID_STANDALONE),
            INTERNET::XML_E_UNEXPECTED_STANDALONE => RawError::Kind(INTERNET::XML_E_UNEXPECTED_STANDALONE),
            INTERNET::XML_E_DOCTYPE_IN_DTD => RawError::Kind(INTERNET::XML_E_DOCTYPE_IN_DTD),
            INTERNET::XML_E_MISSING_ENTITY => RawError::Kind(INTERNET::XML_E_MISSING_ENTITY),
            INTERNET::XML_E_ENTITYREF_INNAME => RawError::Kind(INTERNET::XML_E_ENTITYREF_INNAME),
            INTERNET::XML_E_DOCTYPE_OUTSIDE_PROLOG => RawError::Kind(INTERNET::XML_E_DOCTYPE_OUTSIDE_PROLOG),
            INTERNET::XML_E_INVALID_VERSION => RawError::Kind(INTERNET::XML_E_INVALID_VERSION),
            INTERNET::XML_E_DTDELEMENT_OUTSIDE_DTD => RawError::Kind(INTERNET::XML_E_DTDELEMENT_OUTSIDE_DTD),
            INTERNET::XML_E_DUPLICATEDOCTYPE => RawError::Kind(INTERNET::XML_E_DUPLICATEDOCTYPE),
            INTERNET::XML_E_RESOURCE => RawError::Kind(INTERNET::XML_E_RESOURCE),
            INTERNET::MX_E_MX => RawError::Kind(INTERNET::MX_E_MX),
            INTERNET::MX_E_INPUTEND => RawError::Kind(INTERNET::MX_E_INPUTEND),
            INTERNET::MX_E_ENCODING => RawError::Kind(INTERNET::MX_E_ENCODING),
            INTERNET::MX_E_ENCODINGSWITCH => RawError::Kind(INTERNET::MX_E_ENCODINGSWITCH),
            INTERNET::MX_E_ENCODINGSIGNATURE => RawError::Kind(INTERNET::MX_E_ENCODINGSIGNATURE),
            INTERNET::WC_E_WC => RawError::Kind(INTERNET::WC_E_WC),
            INTERNET::WC_E_WHITESPACE => RawError::Kind(INTERNET::WC_E_WHITESPACE),
            INTERNET::WC_E_SEMICOLON => RawError::Kind(INTERNET::WC_E_SEMICOLON),
            INTERNET::WC_E_GREATERTHAN => RawError::Kind(INTERNET::WC_E_GREATERTHAN),
            INTERNET::WC_E_QUOTE => RawError::Kind(INTERNET::WC_E_QUOTE),
            INTERNET::WC_E_EQUAL => RawError::Kind(INTERNET::WC_E_EQUAL),
            INTERNET::WC_E_LESSTHAN => RawError::Kind(INTERNET::WC_E_LESSTHAN),
            INTERNET::WC_E_HEXDIGIT => RawError::Kind(INTERNET::WC_E_HEXDIGIT),
            INTERNET::WC_E_DIGIT => RawError::Kind(INTERNET::WC_E_DIGIT),
            INTERNET::WC_E_LEFTBRACKET => RawError::Kind(INTERNET::WC_E_LEFTBRACKET),
            INTERNET::WC_E_LEFTPAREN => RawError::Kind(INTERNET::WC_E_LEFTPAREN),
            INTERNET::WC_E_XMLCHARACTER => RawError::Kind(INTERNET::WC_E_XMLCHARACTER),
            INTERNET::WC_E_NAMECHARACTER => RawError::Kind(INTERNET::WC_E_NAMECHARACTER),
            INTERNET::WC_E_SYNTAX => RawError::Kind(INTERNET::WC_E_SYNTAX),
            INTERNET::WC_E_CDSECT => RawError::Kind(INTERNET::WC_E_CDSECT),
            INTERNET::WC_E_COMMENT => RawError::Kind(INTERNET::WC_E_COMMENT),
            INTERNET::WC_E_CONDSECT => RawError::Kind(INTERNET::WC_E_CONDSECT),
            INTERNET::WC_E_DECLATTLIST => RawError::Kind(INTERNET::WC_E_DECLATTLIST),
            INTERNET::WC_E_DECLDOCTYPE => RawError::Kind(INTERNET::WC_E_DECLDOCTYPE),
            INTERNET::WC_E_DECLELEMENT => RawError::Kind(INTERNET::WC_E_DECLELEMENT),
            INTERNET::WC_E_DECLENTITY => RawError::Kind(INTERNET::WC_E_DECLENTITY),
            INTERNET::WC_E_DECLNOTATION => RawError::Kind(INTERNET::WC_E_DECLNOTATION),
            INTERNET::WC_E_NDATA => RawError::Kind(INTERNET::WC_E_NDATA),
            INTERNET::WC_E_PUBLIC => RawError::Kind(INTERNET::WC_E_PUBLIC),
            INTERNET::WC_E_SYSTEM => RawError::Kind(INTERNET::WC_E_SYSTEM),
            INTERNET::WC_E_NAME => RawError::Kind(INTERNET::WC_E_NAME),
            INTERNET::WC_E_ROOTELEMENT => RawError::Kind(INTERNET::WC_E_ROOTELEMENT),
            INTERNET::WC_E_ELEMENTMATCH => RawError::Kind(INTERNET::WC_E_ELEMENTMATCH),
            INTERNET::WC_E_UNIQUEATTRIBUTE => RawError::Kind(INTERNET::WC_E_UNIQUEATTRIBUTE),
            INTERNET::WC_E_TEXTXMLDECL => RawError::Kind(INTERNET::WC_E_TEXTXMLDECL),
            INTERNET::WC_E_LEADINGXML => RawError::Kind(INTERNET::WC_E_LEADINGXML),
            INTERNET::WC_E_TEXTDECL => RawError::Kind(INTERNET::WC_E_TEXTDECL),
            INTERNET::WC_E_XMLDECL => RawError::Kind(INTERNET::WC_E_XMLDECL),
            INTERNET::WC_E_ENCNAME => RawError::Kind(INTERNET::WC_E_ENCNAME),
            INTERNET::WC_E_PUBLICID => RawError::Kind(INTERNET::WC_E_PUBLICID),
            INTERNET::WC_E_PESINTERNALSUBSET => RawError::Kind(INTERNET::WC_E_PESINTERNALSUBSET),
            INTERNET::WC_E_PESBETWEENDECLS => RawError::Kind(INTERNET::WC_E_PESBETWEENDECLS),
            INTERNET::WC_E_NORECURSION => RawError::Kind(INTERNET::WC_E_NORECURSION),
            INTERNET::WC_E_ENTITYCONTENT => RawError::Kind(INTERNET::WC_E_ENTITYCONTENT),
            INTERNET::WC_E_UNDECLAREDENTITY => RawError::Kind(INTERNET::WC_E_UNDECLAREDENTITY),
            INTERNET::WC_E_PARSEDENTITY => RawError::Kind(INTERNET::WC_E_PARSEDENTITY),
            INTERNET::WC_E_NOEXTERNALENTITYREF => RawError::Kind(INTERNET::WC_E_NOEXTERNALENTITYREF),
            INTERNET::WC_E_PI => RawError::Kind(INTERNET::WC_E_PI),
            INTERNET::WC_E_SYSTEMID => RawError::Kind(INTERNET::WC_E_SYSTEMID),
            INTERNET::WC_E_QUESTIONMARK => RawError::Kind(INTERNET::WC_E_QUESTIONMARK),
            INTERNET::WC_E_CDSECTEND => RawError::Kind(INTERNET::WC_E_CDSECTEND),
            INTERNET::WC_E_MOREDATA => RawError::Kind(INTERNET::WC_E_MOREDATA),
            INTERNET::WC_E_DTDPROHIBITED => RawError::Kind(INTERNET::WC_E_DTDPROHIBITED),
            INTERNET::WC_E_INVALIDXMLSPACE => RawError::Kind(INTERNET::WC_E_INVALIDXMLSPACE),
            INTERNET::NC_E_NC => RawError::Kind(INTERNET::NC_E_NC),
            INTERNET::NC_E_QNAMECHARACTER => RawError::Kind(INTERNET::NC_E_QNAMECHARACTER),
            INTERNET::NC_E_QNAMECOLON => RawError::Kind(INTERNET::NC_E_QNAMECOLON),
            INTERNET::NC_E_NAMECOLON => RawError::Kind(INTERNET::NC_E_NAMECOLON),
            INTERNET::NC_E_DECLAREDPREFIX => RawError::Kind(INTERNET::NC_E_DECLAREDPREFIX),
            INTERNET::NC_E_UNDECLAREDPREFIX => RawError::Kind(INTERNET::NC_E_UNDECLAREDPREFIX),
            INTERNET::NC_E_EMPTYURI => RawError::Kind(INTERNET::NC_E_EMPTYURI),
            INTERNET::NC_E_XMLPREFIXRESERVED => RawError::Kind(INTERNET::NC_E_XMLPREFIXRESERVED),
            INTERNET::NC_E_XMLNSPREFIXRESERVED => RawError::Kind(INTERNET::NC_E_XMLNSPREFIXRESERVED),
            INTERNET::NC_E_XMLURIRESERVED => RawError::Kind(INTERNET::NC_E_XMLURIRESERVED),
            INTERNET::NC_E_XMLNSURIRESERVED => RawError::Kind(INTERNET::NC_E_XMLNSURIRESERVED),
            INTERNET::SC_E_SC => RawError::Kind(INTERNET::SC_E_SC),
            INTERNET::SC_E_MAXELEMENTDEPTH => RawError::Kind(INTERNET::SC_E_MAXELEMENTDEPTH),
            INTERNET::SC_E_MAXENTITYEXPANSION => RawError::Kind(INTERNET::SC_E_MAXENTITYEXPANSION),
            INTERNET::WR_E_WR => RawError::Kind(INTERNET::WR_E_WR),
            INTERNET::WR_E_NONWHITESPACE => RawError::Kind(INTERNET::WR_E_NONWHITESPACE),
            INTERNET::WR_E_NSPREFIXDECLARED => RawError::Kind(INTERNET::WR_E_NSPREFIXDECLARED),
            INTERNET::WR_E_NSPREFIXWITHEMPTYNSURI => RawError::Kind(INTERNET::WR_E_NSPREFIXWITHEMPTYNSURI),
            INTERNET::WR_E_DUPLICATEATTRIBUTE => RawError::Kind(INTERNET::WR_E_DUPLICATEATTRIBUTE),
            INTERNET::WR_E_XMLNSPREFIXDECLARATION => RawError::Kind(INTERNET::WR_E_XMLNSPREFIXDECLARATION),
            INTERNET::WR_E_XMLPREFIXDECLARATION => RawError::Kind(INTERNET::WR_E_XMLPREFIXDECLARATION),
            INTERNET::WR_E_XMLURIDECLARATION => RawError::Kind(INTERNET::WR_E_XMLURIDECLARATION),
            INTERNET::WR_E_XMLNSURIDECLARATION => RawError::Kind(INTERNET::WR_E_XMLNSURIDECLARATION),
            INTERNET::WR_E_NAMESPACEUNDECLARED => RawError::Kind(INTERNET::WR_E_NAMESPACEUNDECLARED),
            INTERNET::WR_E_INVALIDXMLSPACE => RawError::Kind(INTERNET::WR_E_INVALIDXMLSPACE),
            INTERNET::WR_E_INVALIDACTION => RawError::Kind(INTERNET::WR_E_INVALIDACTION),
            INTERNET::WR_E_INVALIDSURROGATEPAIR => RawError::Kind(INTERNET::WR_E_INVALIDSURROGATEPAIR),
        }
    }

    pub fn description(&self) -> &'static str {
        return match self {
            INTERNET::INET_E_INVALID_URL => "The URL is invalid.",
            INTERNET::INET_E_NO_SESSION => "No Internet session has been established.",
            INTERNET::INET_E_CANNOT_CONNECT => "Unable to connect to the target server.",
            INTERNET::INET_E_RESOURCE_NOT_FOUND => "The system cannot locate the resource specified.",
            INTERNET::INET_E_OBJECT_NOT_FOUND => "The system cannot locate the object specified.",
            INTERNET::INET_E_DATA_NOT_AVAILABLE => "No data is available for the requested resource.",
            INTERNET::INET_E_DOWNLOAD_FAILURE => "The download of the specified resource has failed.",
            INTERNET::INET_E_AUTHENTICATION_REQUIRED => "Authentication is required to access this resource.",
            INTERNET::INET_E_NO_VALID_MEDIA => "The server could not recognize the provided mime type.",
            INTERNET::INET_E_CONNECTION_TIMEOUT => "The operation was timed out.",
            INTERNET::INET_E_INVALID_REQUEST => "The server did not understand the request, or the request was invalid.",
            INTERNET::INET_E_UNKNOWN_PROTOCOL => "The specified protocol is unknown.",
            INTERNET::INET_E_SECURITY_PROBLEM => "A security problem occurred.",
            INTERNET::INET_E_CANNOT_LOAD_DATA => "The system could not load the persisted data.",
            INTERNET::INET_E_CANNOT_INSTANTIATE_OBJECT => "Unable to instantiate the object.",
            INTERNET::INET_E_REDIRECT_FAILED => "A redirection problem occurred.",
            INTERNET::INET_E_REDIRECT_TO_DIR => "The requested resource is a directory, not a file.",
            INTERNET::INET_E_INVALID_CERTIFICATE => "Security certificate required to access this resource is invalid.",
            INTERNET::XML_E_INVALID_DECIMAL => "Invalid character for decimal digit.",
            INTERNET::XML_E_INVALID_HEXIDECIMAL => "Invalid character for hexadecimal digit.",
            INTERNET::XML_E_INVALID_UNICODE => "Invalid Unicode character value for this platform.",
            INTERNET::XML_E_INVALIDENCODING => "System does not support the specified encoding.",
            INTERNET::XML_E_FORMATINDEX_BADINDEX => "The value passed in to formatIndex must be greater than 0.",
            INTERNET::XML_E_FORMATINDEX_BADFORMAT => "Invalid format string.",
            INTERNET::XML_E_EXPECTED_TOKEN => "Expected token %1 found %2.",
            INTERNET::XML_E_UNEXPECTED_TOKEN => "Unexpected token %1.",
            INTERNET::XML_E_MISSINGEQUALS => "Missing equals sign between attribute and attribute value.",
            INTERNET::XML_E_MISSINGQUOTE => "A string literal was expected, but no opening quote character was found.",
            INTERNET::XML_E_COMMENTSYNTAX => "Incorrect syntax was used in a comment.",
            INTERNET::XML_E_BADSTARTNAMECHAR => "A name was started with an invalid character.",
            INTERNET::XML_E_BADNAMECHAR => "A name contained an invalid character.",
            INTERNET::XML_E_BADCHARINSTRING => "A string literal contained an invalid character.",
            INTERNET::XML_E_XMLDECLSYNTAX => "Invalid syntax for an XML declaration.",
            INTERNET::XML_E_BADCHARDATA => "An invalid character was found in text content.",
            INTERNET::XML_E_MISSINGWHITESPACE => "Required white space was missing.",
            INTERNET::XML_E_EXPECTINGTAGEND => "The character '>'. was expected.",
            INTERNET::XML_E_BADCHARINDTD => "Invalid character found in document type definition (DTD).",
            INTERNET::XML_E_BADCHARINDECL => "An invalid character was found inside a DTD declaration.",
            INTERNET::XML_E_MISSINGSEMICOLON => "A semicolon character was expected.",
            INTERNET::XML_E_BADCHARINENTREF => "An invalid character was found inside an entity reference.",
            INTERNET::XML_E_UNBALANCEDPAREN => "Unbalanced parentheses.",
            INTERNET::XML_E_EXPECTINGOPENBRACKET => "An opening '[' character was expected.",
            INTERNET::XML_E_BADENDCONDSECT => "Invalid syntax in a conditional section.",
            INTERNET::XML_E_INTERNALERROR => "Internal error.",
            INTERNET::XML_E_UNEXPECTED_WHITESPACE => "White space is not allowed at this location.",
            INTERNET::XML_E_INCOMPLETE_ENCODING => "End of file reached in invalid state for current encoding.",
            INTERNET::XML_E_BADCHARINMIXEDMODEL => "Mixed content model cannot contain this character.",
            INTERNET::XML_E_MISSING_STAR => "Mixed content model must be defined as zero or more('*').",
            INTERNET::XML_E_BADCHARINMODEL => "Invalid character in content model.",
            INTERNET::XML_E_MISSING_PAREN => "Missing parenthesis.",
            INTERNET::XML_E_BADCHARINENUMERATION => "Invalid character found in ATTLIST enumeration.",
            INTERNET::XML_E_PIDECLSYNTAX => "Invalid syntax in processing instruction declaration.",
            INTERNET::XML_E_EXPECTINGCLOSEQUOTE => "A single or double closing quote character (\' or \",
            INTERNET::XML_E_MULTIPLE_COLONS => "Multiple colons are not allowed in a name.",
            INTERNET::XML_E_WHITESPACEORQUESTIONMARK => "Expecting white space or '?'.",
            INTERNET::XML_E_SUSPENDED => "The parser is suspended.",
            INTERNET::XML_E_STOPPED => "The parser is stopped.",
            INTERNET::XML_E_UNEXPECTEDENDTAG => "End tag was not expected at this location.",
            INTERNET::XML_E_UNCLOSEDTAG => "The following tags were not closed: %1.",
            INTERNET::XML_E_DUPLICATEATTRIBUTE => "Duplicate attribute.",
            INTERNET::XML_E_MULTIPLEROOTS => "Only one top level element is allowed in an XML document.",
            INTERNET::XML_E_INVALIDATROOTLEVEL => "Invalid at the top level of the document.",
            INTERNET::XML_E_BADXMLDECL => "Invalid XML declaration.",
            INTERNET::XML_E_MISSINGROOT => "XML document must have a top level element.",
            INTERNET::XML_E_UNEXPECTEDEOF => "Unexpected end of file.",
            INTERNET::XML_E_BADPEREFINSUBSET => "Parameter entities cannot be used inside markup declarations in an internal subset.",
            INTERNET::XML_E_PE_NESTING => "The replacement text for a parameter entity must be properly nested with parenthesized groups.",
            INTERNET::XML_E_INVALID_CDATACLOSINGTAG => "The literal string ']]>' is not allowed in element content.",
            INTERNET::XML_E_UNCLOSEDPI => "Processing instruction was not closed.",
            INTERNET::XML_E_UNCLOSEDSTARTTAG => "Element was not closed.",
            INTERNET::XML_E_UNCLOSEDENDTAG => "End element was missing the character '>'.",
            INTERNET::XML_E_UNCLOSEDSTRING => "A string literal was not closed.",
            INTERNET::XML_E_UNCLOSEDCOMMENT => "A comment was not closed.",
            INTERNET::XML_E_UNCLOSEDDECL => "A declaration was not closed.",
            INTERNET::XML_E_UNCLOSEDMARKUPDECL => "A markup declaration was not closed.",
            INTERNET::XML_E_UNCLOSEDCDATA => "A CDATA section was not closed.",
            INTERNET::XML_E_BADDECLNAME => "Declaration has an invalid name.",
            INTERNET::XML_E_BADEXTERNALID => "External ID is invalid.",
            INTERNET::XML_E_BADELEMENTINDTD => "An XML element is not allowed inside a DTD.",
            INTERNET::XML_E_RESERVEDNAMESPACE => "The namespace prefix is not allowed to start with the reserved string 'xml'.",
            INTERNET::XML_E_EXPECTING_VERSION => "The 'version' attribute is required at this location.",
            INTERNET::XML_E_EXPECTING_ENCODING => "The 'encoding' attribute is required at this location.",
            INTERNET::XML_E_EXPECTING_NAME => "At least one name is required at this location.",
            INTERNET::XML_E_UNEXPECTED_ATTRIBUTE => "The specified attribute was not expected at this location. The attribute may be case sensitive.",
            INTERNET::XML_E_ENDTAGMISMATCH => "End tag '%2' does not match the start tag '%1'.",
            INTERNET::XML_E_INVALIDSWITCH => "Switch from current encoding to specified encoding not supported.",
            INTERNET::XML_E_EXPECTING_NDATA => "NDATA keyword is missing.",
            INTERNET::XML_E_INVALID_MODEL => "Content model is invalid.",
            INTERNET::XML_E_INVALID_TYPE => "Invalid type defined in ATTLIST.",
            INTERNET::XML_E_INVALIDXMLSPACE => "XML space attribute has invalid value. Must specify 'default' or 'preserve'.",
            INTERNET::XML_E_MULTI_ATTR_VALUE => "Multiple names found in attribute value when only one was expected.",
            INTERNET::XML_E_INVALID_PRESENCE => "Invalid ATTDEF declaration. Expected #REQUIRED, #IMPLIED or #FIXED.",
            INTERNET::XML_E_BADXMLCASE => "The name 'xml' is reserved and must be lowercase.",
            INTERNET::XML_E_CONDSECTINSUBSET => "Conditional sections are not allowed in an internal subset.",
            INTERNET::XML_E_CDATAINVALID => "CDATA is not allowed in a DTD.",
            INTERNET::XML_E_INVALID_STANDALONE => "The standalone attribute must have the value 'yes' or 'no'.",
            INTERNET::XML_E_UNEXPECTED_STANDALONE => "The standalone attribute cannot be used in external entities.",
            INTERNET::XML_E_DOCTYPE_IN_DTD => "Cannot have a DOCTYPE declaration in a DTD.",
            INTERNET::XML_E_MISSING_ENTITY => "Reference to undefined entity.",
            INTERNET::XML_E_ENTITYREF_INNAME => "Entity reference is resolved to an invalid name character.",
            INTERNET::XML_E_DOCTYPE_OUTSIDE_PROLOG => "Cannot have a DOCTYPE declaration outside of a prolog.",
            INTERNET::XML_E_INVALID_VERSION => "Invalid version number.",
            INTERNET::XML_E_DTDELEMENT_OUTSIDE_DTD => "Cannot have a DTD declaration outside of a DTD.",
            INTERNET::XML_E_DUPLICATEDOCTYPE => "Cannot have multiple DOCTYPE declarations.",
            INTERNET::XML_E_RESOURCE => "Error processing resource '%1'.",
            INTERNET::MX_E_MX => "DUA_E_MALFORMEDXML.",
            INTERNET::MX_E_INPUTEND => "XmlLite: Unexpected end of input.",
            INTERNET::MX_E_ENCODING => "XmlLite: Unrecognized encoding.",
            INTERNET::MX_E_ENCODINGSWITCH => "XmlLite: Unable to switch the encoding.",
            INTERNET::MX_E_ENCODINGSIGNATURE => "XmlLite: Unrecognized input signature.",
            INTERNET::WC_E_WC => "XmlLite:.",
            INTERNET::WC_E_WHITESPACE => "XmlLite: Whitespace expected.",
            INTERNET::WC_E_SEMICOLON => "XmlLite: Semicolon expected.",
            INTERNET::WC_E_GREATERTHAN => "XmlLite: '>'. expected.",
            INTERNET::WC_E_QUOTE => "XmlLite: Quote expected.",
            INTERNET::WC_E_EQUAL => "XmlLite: Equal expected.",
            INTERNET::WC_E_LESSTHAN => "XmlLite: Well-formedness constraint: no '<' in attribute value.",
            INTERNET::WC_E_HEXDIGIT => "XmlLite: Hexadecimal digit expected.",
            INTERNET::WC_E_DIGIT => "XmlLite: Decimal digit expected.",
            INTERNET::WC_E_LEFTBRACKET => "XmlLite: '[' expected.",
            INTERNET::WC_E_LEFTPAREN => "XmlLite: '(' expected.",
            INTERNET::WC_E_XMLCHARACTER => "XmlLite: Illegal xml character.",
            INTERNET::WC_E_NAMECHARACTER => "XmlLite: Illegal name character.",
            INTERNET::WC_E_SYNTAX => "XmlLite: Incorrect document syntax.",
            INTERNET::WC_E_CDSECT => "XmlLite: Incorrect CDATA section syntax.",
            INTERNET::WC_E_COMMENT => "XmlLite: Incorrect comment syntax.",
            INTERNET::WC_E_CONDSECT => "XmlLite: Incorrect conditional section syntax.",
            INTERNET::WC_E_DECLATTLIST => "XmlLite: Incorrect ATTLIST declaration syntax.",
            INTERNET::WC_E_DECLDOCTYPE => "XmlLite: Incorrect DOCTYPE declaration syntax.",
            INTERNET::WC_E_DECLELEMENT => "XmlLite:  Incorrect ELEMENT declaration syntax.",
            INTERNET::WC_E_DECLENTITY => "XmlLite:  Incorrect ENTITY declaration syntax.",
            INTERNET::WC_E_DECLNOTATION => "XmlLite: Incorrect NOTATION declaration syntax.",
            INTERNET::WC_E_NDATA => "XmlLite: NDATA expected.",
            INTERNET::WC_E_PUBLIC => "XmlLite: PUBLIC expected.",
            INTERNET::WC_E_SYSTEM => "XmlLite: SYSTEM expected.",
            INTERNET::WC_E_NAME => "XmlLite: Name expected.",
            INTERNET::WC_E_ROOTELEMENT => "XmlLite: One root element.",
            INTERNET::WC_E_ELEMENTMATCH => "XmlLite: Well-formedness constraint: element type match.",
            INTERNET::WC_E_UNIQUEATTRIBUTE => "XmlLite: Well-formedness constraint: unique attribute spec.",
            INTERNET::WC_E_TEXTXMLDECL => "XmlLite: text/xmldecl not at the beginning of input.",
            INTERNET::WC_E_LEADINGXML => "XmlLite: Leading 'xml'.",
            INTERNET::WC_E_TEXTDECL => "XmlLite: Incorrect text declaration syntax.",
            INTERNET::WC_E_XMLDECL => "XmlLite: Incorrect xml declaration syntax.",
            INTERNET::WC_E_ENCNAME => "XmlLite: Incorrect encoding name syntax.",
            INTERNET::WC_E_PUBLICID => "XmlLite: Incorrect public identifier syntax.",
            INTERNET::WC_E_PESINTERNALSUBSET => "XmlLite: Well-formedness constraint: pes in internal subset.",
            INTERNET::WC_E_PESBETWEENDECLS => "XmlLite: Well-formedness constraint: pes between declarations.",
            INTERNET::WC_E_NORECURSION => "XmlLite: Well-formedness constraint: no recursion.",
            INTERNET::WC_E_ENTITYCONTENT => "XmlLite: Entity content not well formed.",
            INTERNET::WC_E_UNDECLAREDENTITY => "XmlLite: Well-formedness constraint: undeclared entity.",
            INTERNET::WC_E_PARSEDENTITY => "XmlLite: Well-formedness constraint: parsed entity.",
            INTERNET::WC_E_NOEXTERNALENTITYREF => "XmlLite: Well-formedness constraint: no external entity references.",
            INTERNET::WC_E_PI => "XmlLite: Incorrect processing instruction syntax.",
            INTERNET::WC_E_SYSTEMID => "XmlLite: Incorrect system identifier syntax.",
            INTERNET::WC_E_QUESTIONMARK => "XmlLite:  '?' expected.",
            INTERNET::WC_E_CDSECTEND => "XmlLite:  No ']]>' in element content.",
            INTERNET::WC_E_MOREDATA => "XmlLite: Not all chunks of value have been read.",
            INTERNET::WC_E_DTDPROHIBITED => "XmlLite: DTD was found but is prohibited.",
            INTERNET::WC_E_INVALIDXMLSPACE => "XmlLite: xml:space attribute with invalid value.",
            INTERNET::NC_E_NC => "XmlLite: Namespace base error.",
            INTERNET::NC_E_QNAMECHARACTER => "XmlLite: Illegal qualified name character.",
            INTERNET::NC_E_QNAMECOLON => "XmlLite: Multiple colons in qualified name.",
            INTERNET::NC_E_NAMECOLON => "XmlLite: Colon in name.",
            INTERNET::NC_E_DECLAREDPREFIX => "XmlLite: Declared prefix.",
            INTERNET::NC_E_UNDECLAREDPREFIX => "XmlLite: Undeclared prefix.",
            INTERNET::NC_E_EMPTYURI => "XmlLite: Non default namespace with empty uri.",
            INTERNET::NC_E_XMLPREFIXRESERVED => "XmlLite: 'xml' prefix is reserved and must have the http://www.w3.org/XML/1998/namespace URI.",
            INTERNET::NC_E_XMLNSPREFIXRESERVED => "XmlLite: 'xmlns' prefix is reserved for use by XML.",
            INTERNET::NC_E_XMLURIRESERVED => "XmlLite: xml namespace URI (http://www.w3.org/XML/1998/namespace) must be assigned only to prefix 'xml'.",
            INTERNET::NC_E_XMLNSURIRESERVED => "XmlLite: xmlns namespace URI (http://www.w3.org/2000/xmlns/) is reserved and must not be used.",
            INTERNET::SC_E_SC => "XmlLite: Nodes base error.",
            INTERNET::SC_E_MAXELEMENTDEPTH => "XmlLite: Element depth exceeds limit in XmlReaderProperty_MaxElementDepth.",
            INTERNET::SC_E_MAXENTITYEXPANSION => "XmlLite: Entity expansion exceeds limit in XmlReaderProperty_MaxEntityExpansion.",
            INTERNET::WR_E_WR => "XmlLite: writer base error.",
            INTERNET::WR_E_NONWHITESPACE => "XmlLite: writer: specified string is not whitespace.",
            INTERNET::WR_E_NSPREFIXDECLARED => "XmlLite: writer: namespace prefix is already declared with a different namespace.",
            INTERNET::WR_E_NSPREFIXWITHEMPTYNSURI => "XmlLite: writer: It is not allowed to declare a namespace prefix with empty URI (for example xmlns:p='').",
            INTERNET::WR_E_DUPLICATEATTRIBUTE => "XmlLite: writer: duplicate attribute.",
            INTERNET::WR_E_XMLNSPREFIXDECLARATION => "XmlLite: writer: can not redefine the xmlns prefix.",
            INTERNET::WR_E_XMLPREFIXDECLARATION => "XmlLite: writer: xml prefix must have the http://www.w3.org/XML/1998/namespace URI.",
            INTERNET::WR_E_XMLURIDECLARATION => "XmlLite: writer: xml namespace URI (http://www.w3.org/XML/1998/namespace) must be assigned only to prefix 'xml'.",
            INTERNET::WR_E_XMLNSURIDECLARATION => "XmlLite: writer: xmlns namespace URI (http://www.w3.org/2000/xmlns/) is reserved and must not be used.",
            INTERNET::WR_E_NAMESPACEUNDECLARED => "XmlLite: writer: namespace is not declared.",
            INTERNET::WR_E_INVALIDXMLSPACE => "XmlLite: writer: invalid value of xml:space attribute (allowed values are 'default' and 'preserve').",
            INTERNET::WR_E_INVALIDACTION => "XmlLite: writer: performing the requested action would result in invalid XML document.",
            INTERNET::WR_E_INVALIDSURROGATEPAIR => "XmlLite: writer: input contains invalid or incomplete surrogate pair.",
        }
    }

    pub fn from_name(name: &str) -> INTERNET {
        return match name {
            "INET_E_INVALID_URL" => INTERNET::INET_E_INVALID_URL,
            "INET_E_NO_SESSION" => INTERNET::INET_E_NO_SESSION,
            "INET_E_CANNOT_CONNECT" => INTERNET::INET_E_CANNOT_CONNECT,
            "INET_E_RESOURCE_NOT_FOUND" => INTERNET::INET_E_RESOURCE_NOT_FOUND,
            "INET_E_OBJECT_NOT_FOUND" => INTERNET::INET_E_OBJECT_NOT_FOUND,
            "INET_E_DATA_NOT_AVAILABLE" => INTERNET::INET_E_DATA_NOT_AVAILABLE,
            "INET_E_DOWNLOAD_FAILURE" => INTERNET::INET_E_DOWNLOAD_FAILURE,
            "INET_E_AUTHENTICATION_REQUIRED" => INTERNET::INET_E_AUTHENTICATION_REQUIRED,
            "INET_E_NO_VALID_MEDIA" => INTERNET::INET_E_NO_VALID_MEDIA,
            "INET_E_CONNECTION_TIMEOUT" => INTERNET::INET_E_CONNECTION_TIMEOUT,
            "INET_E_INVALID_REQUEST" => INTERNET::INET_E_INVALID_REQUEST,
            "INET_E_UNKNOWN_PROTOCOL" => INTERNET::INET_E_UNKNOWN_PROTOCOL,
            "INET_E_SECURITY_PROBLEM" => INTERNET::INET_E_SECURITY_PROBLEM,
            "INET_E_CANNOT_LOAD_DATA" => INTERNET::INET_E_CANNOT_LOAD_DATA,
            "INET_E_CANNOT_INSTANTIATE_OBJECT" => INTERNET::INET_E_CANNOT_INSTANTIATE_OBJECT,
            "INET_E_REDIRECT_FAILED" => INTERNET::INET_E_REDIRECT_FAILED,
            "INET_E_REDIRECT_TO_DIR" => INTERNET::INET_E_REDIRECT_TO_DIR,
            "INET_E_INVALID_CERTIFICATE" => INTERNET::INET_E_INVALID_CERTIFICATE,
            "XML_E_INVALID_DECIMAL" => INTERNET::XML_E_INVALID_DECIMAL,
            "XML_E_INVALID_HEXIDECIMAL" => INTERNET::XML_E_INVALID_HEXIDECIMAL,
            "XML_E_INVALID_UNICODE" => INTERNET::XML_E_INVALID_UNICODE,
            "XML_E_INVALIDENCODING" => INTERNET::XML_E_INVALIDENCODING,
            "XML_E_FORMATINDEX_BADINDEX" => INTERNET::XML_E_FORMATINDEX_BADINDEX,
            "XML_E_FORMATINDEX_BADFORMAT" => INTERNET::XML_E_FORMATINDEX_BADFORMAT,
            "XML_E_EXPECTED_TOKEN" => INTERNET::XML_E_EXPECTED_TOKEN,
            "XML_E_UNEXPECTED_TOKEN" => INTERNET::XML_E_UNEXPECTED_TOKEN,
            "XML_E_MISSINGEQUALS" => INTERNET::XML_E_MISSINGEQUALS,
            "XML_E_MISSINGQUOTE" => INTERNET::XML_E_MISSINGQUOTE,
            "XML_E_COMMENTSYNTAX" => INTERNET::XML_E_COMMENTSYNTAX,
            "XML_E_BADSTARTNAMECHAR" => INTERNET::XML_E_BADSTARTNAMECHAR,
            "XML_E_BADNAMECHAR" => INTERNET::XML_E_BADNAMECHAR,
            "XML_E_BADCHARINSTRING" => INTERNET::XML_E_BADCHARINSTRING,
            "XML_E_XMLDECLSYNTAX" => INTERNET::XML_E_XMLDECLSYNTAX,
            "XML_E_BADCHARDATA" => INTERNET::XML_E_BADCHARDATA,
            "XML_E_MISSINGWHITESPACE" => INTERNET::XML_E_MISSINGWHITESPACE,
            "XML_E_EXPECTINGTAGEND" => INTERNET::XML_E_EXPECTINGTAGEND,
            "XML_E_BADCHARINDTD" => INTERNET::XML_E_BADCHARINDTD,
            "XML_E_BADCHARINDECL" => INTERNET::XML_E_BADCHARINDECL,
            "XML_E_MISSINGSEMICOLON" => INTERNET::XML_E_MISSINGSEMICOLON,
            "XML_E_BADCHARINENTREF" => INTERNET::XML_E_BADCHARINENTREF,
            "XML_E_UNBALANCEDPAREN" => INTERNET::XML_E_UNBALANCEDPAREN,
            "XML_E_EXPECTINGOPENBRACKET" => INTERNET::XML_E_EXPECTINGOPENBRACKET,
            "XML_E_BADENDCONDSECT" => INTERNET::XML_E_BADENDCONDSECT,
            "XML_E_INTERNALERROR" => INTERNET::XML_E_INTERNALERROR,
            "XML_E_UNEXPECTED_WHITESPACE" => INTERNET::XML_E_UNEXPECTED_WHITESPACE,
            "XML_E_INCOMPLETE_ENCODING" => INTERNET::XML_E_INCOMPLETE_ENCODING,
            "XML_E_BADCHARINMIXEDMODEL" => INTERNET::XML_E_BADCHARINMIXEDMODEL,
            "XML_E_MISSING_STAR" => INTERNET::XML_E_MISSING_STAR,
            "XML_E_BADCHARINMODEL" => INTERNET::XML_E_BADCHARINMODEL,
            "XML_E_MISSING_PAREN" => INTERNET::XML_E_MISSING_PAREN,
            "XML_E_BADCHARINENUMERATION" => INTERNET::XML_E_BADCHARINENUMERATION,
            "XML_E_PIDECLSYNTAX" => INTERNET::XML_E_PIDECLSYNTAX,
            "XML_E_EXPECTINGCLOSEQUOTE" => INTERNET::XML_E_EXPECTINGCLOSEQUOTE,
            "XML_E_MULTIPLE_COLONS" => INTERNET::XML_E_MULTIPLE_COLONS,
            "XML_E_WHITESPACEORQUESTIONMARK" => INTERNET::XML_E_WHITESPACEORQUESTIONMARK,
            "XML_E_SUSPENDED" => INTERNET::XML_E_SUSPENDED,
            "XML_E_STOPPED" => INTERNET::XML_E_STOPPED,
            "XML_E_UNEXPECTEDENDTAG" => INTERNET::XML_E_UNEXPECTEDENDTAG,
            "XML_E_UNCLOSEDTAG" => INTERNET::XML_E_UNCLOSEDTAG,
            "XML_E_DUPLICATEATTRIBUTE" => INTERNET::XML_E_DUPLICATEATTRIBUTE,
            "XML_E_MULTIPLEROOTS" => INTERNET::XML_E_MULTIPLEROOTS,
            "XML_E_INVALIDATROOTLEVEL" => INTERNET::XML_E_INVALIDATROOTLEVEL,
            "XML_E_BADXMLDECL" => INTERNET::XML_E_BADXMLDECL,
            "XML_E_MISSINGROOT" => INTERNET::XML_E_MISSINGROOT,
            "XML_E_UNEXPECTEDEOF" => INTERNET::XML_E_UNEXPECTEDEOF,
            "XML_E_BADPEREFINSUBSET" => INTERNET::XML_E_BADPEREFINSUBSET,
            "XML_E_PE_NESTING" => INTERNET::XML_E_PE_NESTING,
            "XML_E_INVALID_CDATACLOSINGTAG" => INTERNET::XML_E_INVALID_CDATACLOSINGTAG,
            "XML_E_UNCLOSEDPI" => INTERNET::XML_E_UNCLOSEDPI,
            "XML_E_UNCLOSEDSTARTTAG" => INTERNET::XML_E_UNCLOSEDSTARTTAG,
            "XML_E_UNCLOSEDENDTAG" => INTERNET::XML_E_UNCLOSEDENDTAG,
            "XML_E_UNCLOSEDSTRING" => INTERNET::XML_E_UNCLOSEDSTRING,
            "XML_E_UNCLOSEDCOMMENT" => INTERNET::XML_E_UNCLOSEDCOMMENT,
            "XML_E_UNCLOSEDDECL" => INTERNET::XML_E_UNCLOSEDDECL,
            "XML_E_UNCLOSEDMARKUPDECL" => INTERNET::XML_E_UNCLOSEDMARKUPDECL,
            "XML_E_UNCLOSEDCDATA" => INTERNET::XML_E_UNCLOSEDCDATA,
            "XML_E_BADDECLNAME" => INTERNET::XML_E_BADDECLNAME,
            "XML_E_BADEXTERNALID" => INTERNET::XML_E_BADEXTERNALID,
            "XML_E_BADELEMENTINDTD" => INTERNET::XML_E_BADELEMENTINDTD,
            "XML_E_RESERVEDNAMESPACE" => INTERNET::XML_E_RESERVEDNAMESPACE,
            "XML_E_EXPECTING_VERSION" => INTERNET::XML_E_EXPECTING_VERSION,
            "XML_E_EXPECTING_ENCODING" => INTERNET::XML_E_EXPECTING_ENCODING,
            "XML_E_EXPECTING_NAME" => INTERNET::XML_E_EXPECTING_NAME,
            "XML_E_UNEXPECTED_ATTRIBUTE" => INTERNET::XML_E_UNEXPECTED_ATTRIBUTE,
            "XML_E_ENDTAGMISMATCH" => INTERNET::XML_E_ENDTAGMISMATCH,
            "XML_E_INVALIDSWITCH" => INTERNET::XML_E_INVALIDSWITCH,
            "XML_E_EXPECTING_NDATA" => INTERNET::XML_E_EXPECTING_NDATA,
            "XML_E_INVALID_MODEL" => INTERNET::XML_E_INVALID_MODEL,
            "XML_E_INVALID_TYPE" => INTERNET::XML_E_INVALID_TYPE,
            "XML_E_INVALIDXMLSPACE" => INTERNET::XML_E_INVALIDXMLSPACE,
            "XML_E_MULTI_ATTR_VALUE" => INTERNET::XML_E_MULTI_ATTR_VALUE,
            "XML_E_INVALID_PRESENCE" => INTERNET::XML_E_INVALID_PRESENCE,
            "XML_E_BADXMLCASE" => INTERNET::XML_E_BADXMLCASE,
            "XML_E_CONDSECTINSUBSET" => INTERNET::XML_E_CONDSECTINSUBSET,
            "XML_E_CDATAINVALID" => INTERNET::XML_E_CDATAINVALID,
            "XML_E_INVALID_STANDALONE" => INTERNET::XML_E_INVALID_STANDALONE,
            "XML_E_UNEXPECTED_STANDALONE" => INTERNET::XML_E_UNEXPECTED_STANDALONE,
            "XML_E_DOCTYPE_IN_DTD" => INTERNET::XML_E_DOCTYPE_IN_DTD,
            "XML_E_MISSING_ENTITY" => INTERNET::XML_E_MISSING_ENTITY,
            "XML_E_ENTITYREF_INNAME" => INTERNET::XML_E_ENTITYREF_INNAME,
            "XML_E_DOCTYPE_OUTSIDE_PROLOG" => INTERNET::XML_E_DOCTYPE_OUTSIDE_PROLOG,
            "XML_E_INVALID_VERSION" => INTERNET::XML_E_INVALID_VERSION,
            "XML_E_DTDELEMENT_OUTSIDE_DTD" => INTERNET::XML_E_DTDELEMENT_OUTSIDE_DTD,
            "XML_E_DUPLICATEDOCTYPE" => INTERNET::XML_E_DUPLICATEDOCTYPE,
            "XML_E_RESOURCE" => INTERNET::XML_E_RESOURCE,
            "MX_E_MX" => INTERNET::MX_E_MX,
            "MX_E_INPUTEND" => INTERNET::MX_E_INPUTEND,
            "MX_E_ENCODING" => INTERNET::MX_E_ENCODING,
            "MX_E_ENCODINGSWITCH" => INTERNET::MX_E_ENCODINGSWITCH,
            "MX_E_ENCODINGSIGNATURE" => INTERNET::MX_E_ENCODINGSIGNATURE,
            "WC_E_WC" => INTERNET::WC_E_WC,
            "WC_E_WHITESPACE" => INTERNET::WC_E_WHITESPACE,
            "WC_E_SEMICOLON" => INTERNET::WC_E_SEMICOLON,
            "WC_E_GREATERTHAN" => INTERNET::WC_E_GREATERTHAN,
            "WC_E_QUOTE" => INTERNET::WC_E_QUOTE,
            "WC_E_EQUAL" => INTERNET::WC_E_EQUAL,
            "WC_E_LESSTHAN" => INTERNET::WC_E_LESSTHAN,
            "WC_E_HEXDIGIT" => INTERNET::WC_E_HEXDIGIT,
            "WC_E_DIGIT" => INTERNET::WC_E_DIGIT,
            "WC_E_LEFTBRACKET" => INTERNET::WC_E_LEFTBRACKET,
            "WC_E_LEFTPAREN" => INTERNET::WC_E_LEFTPAREN,
            "WC_E_XMLCHARACTER" => INTERNET::WC_E_XMLCHARACTER,
            "WC_E_NAMECHARACTER" => INTERNET::WC_E_NAMECHARACTER,
            "WC_E_SYNTAX" => INTERNET::WC_E_SYNTAX,
            "WC_E_CDSECT" => INTERNET::WC_E_CDSECT,
            "WC_E_COMMENT" => INTERNET::WC_E_COMMENT,
            "WC_E_CONDSECT" => INTERNET::WC_E_CONDSECT,
            "WC_E_DECLATTLIST" => INTERNET::WC_E_DECLATTLIST,
            "WC_E_DECLDOCTYPE" => INTERNET::WC_E_DECLDOCTYPE,
            "WC_E_DECLELEMENT" => INTERNET::WC_E_DECLELEMENT,
            "WC_E_DECLENTITY" => INTERNET::WC_E_DECLENTITY,
            "WC_E_DECLNOTATION" => INTERNET::WC_E_DECLNOTATION,
            "WC_E_NDATA" => INTERNET::WC_E_NDATA,
            "WC_E_PUBLIC" => INTERNET::WC_E_PUBLIC,
            "WC_E_SYSTEM" => INTERNET::WC_E_SYSTEM,
            "WC_E_NAME" => INTERNET::WC_E_NAME,
            "WC_E_ROOTELEMENT" => INTERNET::WC_E_ROOTELEMENT,
            "WC_E_ELEMENTMATCH" => INTERNET::WC_E_ELEMENTMATCH,
            "WC_E_UNIQUEATTRIBUTE" => INTERNET::WC_E_UNIQUEATTRIBUTE,
            "WC_E_TEXTXMLDECL" => INTERNET::WC_E_TEXTXMLDECL,
            "WC_E_LEADINGXML" => INTERNET::WC_E_LEADINGXML,
            "WC_E_TEXTDECL" => INTERNET::WC_E_TEXTDECL,
            "WC_E_XMLDECL" => INTERNET::WC_E_XMLDECL,
            "WC_E_ENCNAME" => INTERNET::WC_E_ENCNAME,
            "WC_E_PUBLICID" => INTERNET::WC_E_PUBLICID,
            "WC_E_PESINTERNALSUBSET" => INTERNET::WC_E_PESINTERNALSUBSET,
            "WC_E_PESBETWEENDECLS" => INTERNET::WC_E_PESBETWEENDECLS,
            "WC_E_NORECURSION" => INTERNET::WC_E_NORECURSION,
            "WC_E_ENTITYCONTENT" => INTERNET::WC_E_ENTITYCONTENT,
            "WC_E_UNDECLAREDENTITY" => INTERNET::WC_E_UNDECLAREDENTITY,
            "WC_E_PARSEDENTITY" => INTERNET::WC_E_PARSEDENTITY,
            "WC_E_NOEXTERNALENTITYREF" => INTERNET::WC_E_NOEXTERNALENTITYREF,
            "WC_E_PI" => INTERNET::WC_E_PI,
            "WC_E_SYSTEMID" => INTERNET::WC_E_SYSTEMID,
            "WC_E_QUESTIONMARK" => INTERNET::WC_E_QUESTIONMARK,
            "WC_E_CDSECTEND" => INTERNET::WC_E_CDSECTEND,
            "WC_E_MOREDATA" => INTERNET::WC_E_MOREDATA,
            "WC_E_DTDPROHIBITED" => INTERNET::WC_E_DTDPROHIBITED,
            "WC_E_INVALIDXMLSPACE" => INTERNET::WC_E_INVALIDXMLSPACE,
            "NC_E_NC" => INTERNET::NC_E_NC,
            "NC_E_QNAMECHARACTER" => INTERNET::NC_E_QNAMECHARACTER,
            "NC_E_QNAMECOLON" => INTERNET::NC_E_QNAMECOLON,
            "NC_E_NAMECOLON" => INTERNET::NC_E_NAMECOLON,
            "NC_E_DECLAREDPREFIX" => INTERNET::NC_E_DECLAREDPREFIX,
            "NC_E_UNDECLAREDPREFIX" => INTERNET::NC_E_UNDECLAREDPREFIX,
            "NC_E_EMPTYURI" => INTERNET::NC_E_EMPTYURI,
            "NC_E_XMLPREFIXRESERVED" => INTERNET::NC_E_XMLPREFIXRESERVED,
            "NC_E_XMLNSPREFIXRESERVED" => INTERNET::NC_E_XMLNSPREFIXRESERVED,
            "NC_E_XMLURIRESERVED" => INTERNET::NC_E_XMLURIRESERVED,
            "NC_E_XMLNSURIRESERVED" => INTERNET::NC_E_XMLNSURIRESERVED,
            "SC_E_SC" => INTERNET::SC_E_SC,
            "SC_E_MAXELEMENTDEPTH" => INTERNET::SC_E_MAXELEMENTDEPTH,
            "SC_E_MAXENTITYEXPANSION" => INTERNET::SC_E_MAXENTITYEXPANSION,
            "WR_E_WR" => INTERNET::WR_E_WR,
            "WR_E_NONWHITESPACE" => INTERNET::WR_E_NONWHITESPACE,
            "WR_E_NSPREFIXDECLARED" => INTERNET::WR_E_NSPREFIXDECLARED,
            "WR_E_NSPREFIXWITHEMPTYNSURI" => INTERNET::WR_E_NSPREFIXWITHEMPTYNSURI,
            "WR_E_DUPLICATEATTRIBUTE" => INTERNET::WR_E_DUPLICATEATTRIBUTE,
            "WR_E_XMLNSPREFIXDECLARATION" => INTERNET::WR_E_XMLNSPREFIXDECLARATION,
            "WR_E_XMLPREFIXDECLARATION" => INTERNET::WR_E_XMLPREFIXDECLARATION,
            "WR_E_XMLURIDECLARATION" => INTERNET::WR_E_XMLURIDECLARATION,
            "WR_E_XMLNSURIDECLARATION" => INTERNET::WR_E_XMLNSURIDECLARATION,
            "WR_E_NAMESPACEUNDECLARED" => INTERNET::WR_E_NAMESPACEUNDECLARED,
            "WR_E_INVALIDXMLSPACE" => INTERNET::WR_E_INVALIDXMLSPACE,
            "WR_E_INVALIDACTION" => INTERNET::WR_E_INVALIDACTION,
            "WR_E_INVALIDSURROGATEPAIR" => INTERNET::WR_E_INVALIDSURROGATEPAIR,
        }
    }
    pub fn from_code(code: u32) -> INTERNET {
        return match code {
            0x800C0002 => INTERNET::INET_E_INVALID_URL,
            0x800C0003 => INTERNET::INET_E_NO_SESSION,
            0x800C0004 => INTERNET::INET_E_CANNOT_CONNECT,
            0x800C0005 => INTERNET::INET_E_RESOURCE_NOT_FOUND,
            0x800C0006 => INTERNET::INET_E_OBJECT_NOT_FOUND,
            0x800C0007 => INTERNET::INET_E_DATA_NOT_AVAILABLE,
            0x800C0008 => INTERNET::INET_E_DOWNLOAD_FAILURE,
            0x800C0009 => INTERNET::INET_E_AUTHENTICATION_REQUIRED,
            0x800C000A => INTERNET::INET_E_NO_VALID_MEDIA,
            0x800C000B => INTERNET::INET_E_CONNECTION_TIMEOUT,
            0x800C000C => INTERNET::INET_E_INVALID_REQUEST,
            0x800C000D => INTERNET::INET_E_UNKNOWN_PROTOCOL,
            0x800C000E => INTERNET::INET_E_SECURITY_PROBLEM,
            0x800C000F => INTERNET::INET_E_CANNOT_LOAD_DATA,
            0x800C0010 => INTERNET::INET_E_CANNOT_INSTANTIATE_OBJECT,
            0x800C0014 => INTERNET::INET_E_REDIRECT_FAILED,
            0x800C0015 => INTERNET::INET_E_REDIRECT_TO_DIR,
            0x800C0019 => INTERNET::INET_E_INVALID_CERTIFICATE,
            0xC00CE01D => INTERNET::XML_E_INVALID_DECIMAL,
            0xC00CE01E => INTERNET::XML_E_INVALID_HEXIDECIMAL,
            0xC00CE01F => INTERNET::XML_E_INVALID_UNICODE,
            0xC00CE06E => INTERNET::XML_E_INVALIDENCODING,
            0xC00CE306 => INTERNET::XML_E_FORMATINDEX_BADINDEX,
            0xC00CE307 => INTERNET::XML_E_FORMATINDEX_BADFORMAT,
            0xC00CE380 => INTERNET::XML_E_EXPECTED_TOKEN,
            0xC00CE381 => INTERNET::XML_E_UNEXPECTED_TOKEN,
            0xC00CE501 => INTERNET::XML_E_MISSINGEQUALS,
            0xC00CE502 => INTERNET::XML_E_MISSINGQUOTE,
            0xC00CE503 => INTERNET::XML_E_COMMENTSYNTAX,
            0xC00CE504 => INTERNET::XML_E_BADSTARTNAMECHAR,
            0xC00CE505 => INTERNET::XML_E_BADNAMECHAR,
            0xC00CE506 => INTERNET::XML_E_BADCHARINSTRING,
            0xC00CE507 => INTERNET::XML_E_XMLDECLSYNTAX,
            0xC00CE508 => INTERNET::XML_E_BADCHARDATA,
            0xC00CE509 => INTERNET::XML_E_MISSINGWHITESPACE,
            0xC00CE50A => INTERNET::XML_E_EXPECTINGTAGEND,
            0xC00CE50B => INTERNET::XML_E_BADCHARINDTD,
            0xC00CE50C => INTERNET::XML_E_BADCHARINDECL,
            0xC00CE50D => INTERNET::XML_E_MISSINGSEMICOLON,
            0xC00CE50E => INTERNET::XML_E_BADCHARINENTREF,
            0xC00CE50F => INTERNET::XML_E_UNBALANCEDPAREN,
            0xC00CE510 => INTERNET::XML_E_EXPECTINGOPENBRACKET,
            0xC00CE511 => INTERNET::XML_E_BADENDCONDSECT,
            0xC00CE512 => INTERNET::XML_E_INTERNALERROR,
            0xC00CE513 => INTERNET::XML_E_UNEXPECTED_WHITESPACE,
            0xC00CE514 => INTERNET::XML_E_INCOMPLETE_ENCODING,
            0xC00CE515 => INTERNET::XML_E_BADCHARINMIXEDMODEL,
            0xC00CE516 => INTERNET::XML_E_MISSING_STAR,
            0xC00CE517 => INTERNET::XML_E_BADCHARINMODEL,
            0xC00CE518 => INTERNET::XML_E_MISSING_PAREN,
            0xC00CE519 => INTERNET::XML_E_BADCHARINENUMERATION,
            0xC00CE51A => INTERNET::XML_E_PIDECLSYNTAX,
            0xC00CE51B => INTERNET::XML_E_EXPECTINGCLOSEQUOTE,
            0xC00CE51C => INTERNET::XML_E_MULTIPLE_COLONS,
            0xC00CE520 => INTERNET::XML_E_WHITESPACEORQUESTIONMARK,
            0xC00CE550 => INTERNET::XML_E_SUSPENDED,
            0xC00CE551 => INTERNET::XML_E_STOPPED,
            0xC00CE552 => INTERNET::XML_E_UNEXPECTEDENDTAG,
            0xC00CE553 => INTERNET::XML_E_UNCLOSEDTAG,
            0xC00CE554 => INTERNET::XML_E_DUPLICATEATTRIBUTE,
            0xC00CE555 => INTERNET::XML_E_MULTIPLEROOTS,
            0xC00CE556 => INTERNET::XML_E_INVALIDATROOTLEVEL,
            0xC00CE557 => INTERNET::XML_E_BADXMLDECL,
            0xC00CE558 => INTERNET::XML_E_MISSINGROOT,
            0xC00CE559 => INTERNET::XML_E_UNEXPECTEDEOF,
            0xC00CE55A => INTERNET::XML_E_BADPEREFINSUBSET,
            0xC00CE55B => INTERNET::XML_E_PE_NESTING,
            0xC00CE55C => INTERNET::XML_E_INVALID_CDATACLOSINGTAG,
            0xC00CE55D => INTERNET::XML_E_UNCLOSEDPI,
            0xC00CE55E => INTERNET::XML_E_UNCLOSEDSTARTTAG,
            0xC00CE55F => INTERNET::XML_E_UNCLOSEDENDTAG,
            0xC00CE560 => INTERNET::XML_E_UNCLOSEDSTRING,
            0xC00CE561 => INTERNET::XML_E_UNCLOSEDCOMMENT,
            0xC00CE562 => INTERNET::XML_E_UNCLOSEDDECL,
            0xC00CE563 => INTERNET::XML_E_UNCLOSEDMARKUPDECL,
            0xC00CE564 => INTERNET::XML_E_UNCLOSEDCDATA,
            0xC00CE565 => INTERNET::XML_E_BADDECLNAME,
            0xC00CE566 => INTERNET::XML_E_BADEXTERNALID,
            0xC00CE567 => INTERNET::XML_E_BADELEMENTINDTD,
            0xC00CE568 => INTERNET::XML_E_RESERVEDNAMESPACE,
            0xC00CE569 => INTERNET::XML_E_EXPECTING_VERSION,
            0xC00CE56A => INTERNET::XML_E_EXPECTING_ENCODING,
            0xC00CE56B => INTERNET::XML_E_EXPECTING_NAME,
            0xC00CE56C => INTERNET::XML_E_UNEXPECTED_ATTRIBUTE,
            0xC00CE56D => INTERNET::XML_E_ENDTAGMISMATCH,
            0xC00CE56F => INTERNET::XML_E_INVALIDSWITCH,
            0xC00CE570 => INTERNET::XML_E_EXPECTING_NDATA,
            0xC00CE571 => INTERNET::XML_E_INVALID_MODEL,
            0xC00CE572 => INTERNET::XML_E_INVALID_TYPE,
            0xC00CE573 => INTERNET::XML_E_INVALIDXMLSPACE,
            0xC00CE574 => INTERNET::XML_E_MULTI_ATTR_VALUE,
            0xC00CE575 => INTERNET::XML_E_INVALID_PRESENCE,
            0xC00CE576 => INTERNET::XML_E_BADXMLCASE,
            0xC00CE577 => INTERNET::XML_E_CONDSECTINSUBSET,
            0xC00CE578 => INTERNET::XML_E_CDATAINVALID,
            0xC00CE579 => INTERNET::XML_E_INVALID_STANDALONE,
            0xC00CE57A => INTERNET::XML_E_UNEXPECTED_STANDALONE,
            0xC00CE57B => INTERNET::XML_E_DOCTYPE_IN_DTD,
            0xC00CE57C => INTERNET::XML_E_MISSING_ENTITY,
            0xC00CE57D => INTERNET::XML_E_ENTITYREF_INNAME,
            0xC00CE57E => INTERNET::XML_E_DOCTYPE_OUTSIDE_PROLOG,
            0xC00CE57F => INTERNET::XML_E_INVALID_VERSION,
            0xC00CE580 => INTERNET::XML_E_DTDELEMENT_OUTSIDE_DTD,
            0xC00CE581 => INTERNET::XML_E_DUPLICATEDOCTYPE,
            0xC00CE582 => INTERNET::XML_E_RESOURCE,
            0xC00CEE00 => INTERNET::MX_E_MX,
            0xC00CEE01 => INTERNET::MX_E_INPUTEND,
            0xC00CEE02 => INTERNET::MX_E_ENCODING,
            0xC00CEE03 => INTERNET::MX_E_ENCODINGSWITCH,
            0xC00CEE04 => INTERNET::MX_E_ENCODINGSIGNATURE,
            0xC00CEE20 => INTERNET::WC_E_WC,
            0xC00CEE21 => INTERNET::WC_E_WHITESPACE,
            0xC00CEE22 => INTERNET::WC_E_SEMICOLON,
            0xC00CEE23 => INTERNET::WC_E_GREATERTHAN,
            0xC00CEE24 => INTERNET::WC_E_QUOTE,
            0xC00CEE25 => INTERNET::WC_E_EQUAL,
            0xC00CEE26 => INTERNET::WC_E_LESSTHAN,
            0xC00CEE27 => INTERNET::WC_E_HEXDIGIT,
            0xC00CEE28 => INTERNET::WC_E_DIGIT,
            0xC00CEE29 => INTERNET::WC_E_LEFTBRACKET,
            0xC00CEE2A => INTERNET::WC_E_LEFTPAREN,
            0xC00CEE2B => INTERNET::WC_E_XMLCHARACTER,
            0xC00CEE2C => INTERNET::WC_E_NAMECHARACTER,
            0xC00CEE2D => INTERNET::WC_E_SYNTAX,
            0xC00CEE2E => INTERNET::WC_E_CDSECT,
            0xC00CEE2F => INTERNET::WC_E_COMMENT,
            0xC00CEE30 => INTERNET::WC_E_CONDSECT,
            0xC00CEE31 => INTERNET::WC_E_DECLATTLIST,
            0xC00CEE32 => INTERNET::WC_E_DECLDOCTYPE,
            0xC00CEE33 => INTERNET::WC_E_DECLELEMENT,
            0xC00CEE34 => INTERNET::WC_E_DECLENTITY,
            0xC00CEE35 => INTERNET::WC_E_DECLNOTATION,
            0xC00CEE36 => INTERNET::WC_E_NDATA,
            0xC00CEE37 => INTERNET::WC_E_PUBLIC,
            0xC00CEE38 => INTERNET::WC_E_SYSTEM,
            0xC00CEE39 => INTERNET::WC_E_NAME,
            0xC00CEE3A => INTERNET::WC_E_ROOTELEMENT,
            0xC00CEE3B => INTERNET::WC_E_ELEMENTMATCH,
            0xC00CEE3C => INTERNET::WC_E_UNIQUEATTRIBUTE,
            0xC00CEE3D => INTERNET::WC_E_TEXTXMLDECL,
            0xC00CEE3E => INTERNET::WC_E_LEADINGXML,
            0xC00CEE3F => INTERNET::WC_E_TEXTDECL,
            0xC00CEE40 => INTERNET::WC_E_XMLDECL,
            0xC00CEE41 => INTERNET::WC_E_ENCNAME,
            0xC00CEE42 => INTERNET::WC_E_PUBLICID,
            0xC00CEE43 => INTERNET::WC_E_PESINTERNALSUBSET,
            0xC00CEE44 => INTERNET::WC_E_PESBETWEENDECLS,
            0xC00CEE45 => INTERNET::WC_E_NORECURSION,
            0xC00CEE46 => INTERNET::WC_E_ENTITYCONTENT,
            0xC00CEE47 => INTERNET::WC_E_UNDECLAREDENTITY,
            0xC00CEE48 => INTERNET::WC_E_PARSEDENTITY,
            0xC00CEE49 => INTERNET::WC_E_NOEXTERNALENTITYREF,
            0xC00CEE4A => INTERNET::WC_E_PI,
            0xC00CEE4B => INTERNET::WC_E_SYSTEMID,
            0xC00CEE4C => INTERNET::WC_E_QUESTIONMARK,
            0xC00CEE4D => INTERNET::WC_E_CDSECTEND,
            0xC00CEE4E => INTERNET::WC_E_MOREDATA,
            0xC00CEE4F => INTERNET::WC_E_DTDPROHIBITED,
            0xC00CEE50 => INTERNET::WC_E_INVALIDXMLSPACE,
            0xC00CEE60 => INTERNET::NC_E_NC,
            0xC00CEE61 => INTERNET::NC_E_QNAMECHARACTER,
            0xC00CEE62 => INTERNET::NC_E_QNAMECOLON,
            0xC00CEE63 => INTERNET::NC_E_NAMECOLON,
            0xC00CEE64 => INTERNET::NC_E_DECLAREDPREFIX,
            0xC00CEE65 => INTERNET::NC_E_UNDECLAREDPREFIX,
            0xC00CEE66 => INTERNET::NC_E_EMPTYURI,
            0xC00CEE67 => INTERNET::NC_E_XMLPREFIXRESERVED,
            0xC00CEE68 => INTERNET::NC_E_XMLNSPREFIXRESERVED,
            0xC00CEE69 => INTERNET::NC_E_XMLURIRESERVED,
            0xC00CEE6A => INTERNET::NC_E_XMLNSURIRESERVED,
            0xC00CEE80 => INTERNET::SC_E_SC,
            0xC00CEE81 => INTERNET::SC_E_MAXELEMENTDEPTH,
            0xC00CEE82 => INTERNET::SC_E_MAXENTITYEXPANSION,
            0xC00CEF00 => INTERNET::WR_E_WR,
            0xC00CEF01 => INTERNET::WR_E_NONWHITESPACE,
            0xC00CEF02 => INTERNET::WR_E_NSPREFIXDECLARED,
            0xC00CEF03 => INTERNET::WR_E_NSPREFIXWITHEMPTYNSURI,
            0xC00CEF04 => INTERNET::WR_E_DUPLICATEATTRIBUTE,
            0xC00CEF05 => INTERNET::WR_E_XMLNSPREFIXDECLARATION,
            0xC00CEF06 => INTERNET::WR_E_XMLPREFIXDECLARATION,
            0xC00CEF07 => INTERNET::WR_E_XMLURIDECLARATION,
            0xC00CEF08 => INTERNET::WR_E_XMLNSURIDECLARATION,
            0xC00CEF09 => INTERNET::WR_E_NAMESPACEUNDECLARED,
            0xC00CEF0A => INTERNET::WR_E_INVALIDXMLSPACE,
            0xC00CEF0B => INTERNET::WR_E_INVALIDACTION,
            0xC00CEF0C => INTERNET::WR_E_INVALIDSURROGATEPAIR,
        }
    }
}
